/////////////////////////////////////////////////////////////////////////////
//           HSP Compiler  Ver. 0.3d
//							Copyright 2003 K-K
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "hspcode.h"


unsigned char *dbgbuf;
int dbgpt;
int debugflag=0;
int winflag=0;
char *strbuf;
int strpt;
int codept;
int ocodept;

struct AXHEAD{
	char sig[4];
	long version;
	long valcnt;
	unsigned long file_size;
	unsigned long code_start;
	unsigned long code_size;
	unsigned long str_start;
	unsigned long str_size;
	unsigned long label_start;
	unsigned long label_size;
	unsigned long debug_start;
	unsigned long debug_size;
	unsigned long dlllst_start;
	unsigned long dlllst_size;
	unsigned long dllc_start;
	unsigned long dllc_size;
	unsigned long mod_start;
	unsigned long mod_size;
	unsigned long D[2];
};

struct MODINFO{
	int num;
	unsigned short type;
	short prms;
	int name;
	int pt;
};

struct TABLE{
	int flag;
	int type;
	int code;
	int prmtyp[8];
	char name[64];
};

struct DEFINETBL{
	int flag;
	char name[64];
	char str[512];
};

class CASFile{
public:
	int flag;
	char file[512];
	unsigned char* buf;
	int pt;
	int len;
	int line;
	int load(char *lpPath);
	int set(char *s);
	int sel();
	CASFile(){
		flag=0;
		line=1;
		pt=0;
	}
	~CASFile(){
		if(flag)
			free(buf);
	}
	void del(){
		if(flag)
			free(buf);
		flag=0;
	}
};

int CASFile::set(char *s){
	len=strlen(s);
	buf=(unsigned char*)malloc(len+1);
	memcpy(buf,s,len+1);
	line=-1;
	pt=0;
	flag=1;
	return len;
}

int CASFile::sel(){
	if(debugflag==0)return 0;
	dbgbuf[dbgpt]=0xFE;
	dbgbuf[dbgpt+1]=strpt;
	dbgbuf[dbgpt+2]=strpt>>8;
	dbgbuf[dbgpt+3]=line;
	dbgbuf[dbgpt+4]=line>>8;
	dbgbuf[dbgpt+5]=line>>16;
	dbgpt+=6;
	return len;
}

int CASFile::load(char *lpPath){
	strcpy(file,lpPath);
	FILE *fp=fopen(lpPath,"rb");
	if(fp == NULL){
		return -1;
	}
	fseek(fp,0,SEEK_END); //!? stat()
	len=ftell(fp);
	fseek(fp,0,SEEK_SET);
	buf=(unsigned char*)malloc(len+1);
	fread(buf,1,len,fp);
	fclose(fp);
	buf[len]=0;
	line=0;
	sel();
	if(debugflag){ //line 0?
		strcpy(strbuf+strpt,file);
		strpt+=strlen(file)+1;
		dbgbuf[dbgpt]=0;
		dbgpt++;
	}
	line=1;
	pt=0;
	flag=1;
	return len;
}

CASFile asbuf[20];
int asno=0;

int prmm;
int acmd;
int type;
int data;

int nf,nlf,cf,lf,kf;
int getlne(char *s){
	unsigned char *buf=asbuf[asno].buf;
	int i=0;
	while(buf[asbuf[asno].pt]){
		if(buf[asbuf[asno].pt]==13) break;
		if(buf[asbuf[asno].pt]==10) break;
		if(buf[asbuf[asno].pt]==';') break;
		if(buf[asbuf[asno].pt]=='/' && buf[asbuf[asno].pt+1]=='/') break;
		s[i]=buf[asbuf[asno].pt];
		i++;
		asbuf[asno].pt++;
	}
	s[i]=0;
	return 0;
}
//
//    ȡڤФ
//   flag 1:strbuf˽񤭹 2:Ԥޤʤ
int gettokn(char *s,int flag){
	unsigned char *buf=asbuf[asno].buf;
	static int ef=0;
	int f;
	type=-1;
	nf=0;
	nlf=0;
//	cf=0;
	lf=0;
	if(asbuf[0].pt==0)nf=1;
	if(kf)nf=1;
	int c;
	// ȡڡ֤ɤФ
	while(1){
		if(!buf[asbuf[asno].pt] || asbuf[asno].pt>=asbuf[asno].len){
			if(asbuf[asno].flag){
				asbuf[asno-1].sel();
			}
			asbuf[asno].del();
			if(asno==0)
				return 0;
			asno--;
			buf=asbuf[asno].buf;
		}
		c=buf[asbuf[asno].pt];
		f=0;

		switch(c){
		case '/':
			if(buf[asbuf[asno].pt+1]=='*'){
				while(buf[asbuf[asno].pt] &&
					(buf[asbuf[asno].pt-1]!='*' || buf[asbuf[asno].pt]!='/'))
				{
					asbuf[asno].pt++;
				}
				break;
			}else if(buf[asbuf[asno].pt+1]!='/'){
				f=1;
				break;
			}
		case ';':
			while(buf[asbuf[asno].pt] && buf[asbuf[asno].pt]!=10 && buf[asbuf[asno].pt]!=13){
				asbuf[asno].pt++;
			}
		case 13:
			if(buf[asbuf[asno].pt+1]==10){ //Win
				asbuf[asno].pt++;
			}
		case 10:
			if(flag&2) return 0;
			nf=1;
			nlf=1;
			asbuf[asno].line++;
			if(debugflag){
				dbgbuf[dbgpt]=(codept-ocodept)>>1;
				ocodept=codept;
				dbgpt++;
			}
			break;
		case ',':
			cf=1;
			prmm++;
			break;
		case ':':
			nf=1;
			break;
		default:
			f=1;
		}
		if(c<=' '){
			asbuf[asno].pt++;
			continue;
		}
		if(f) break;
		asbuf[asno].pt++;
	}
	//printf("%d :%d ok\n",aspt,c);

	if(nf){
		//printf("nf\n");
		prmm=0;
		acmd=-1;
	}
	if(asbuf[asno].pt>=asbuf[asno].len){
		if(asbuf[asno].flag){
			asbuf[asno-1].sel();
		}
		asbuf[asno].del();
		if(asno>0)
			asno--;
		printf("debug: Error 1\n");
		return 0;
	}

	c=buf[asbuf[asno].pt];
	if(c=='*' && nf){
		//٥
		lf=1;
		asbuf[asno].pt++;
		c=buf[asbuf[asno].pt];
	}
	int p1=asbuf[asno].pt;
	asbuf[asno].pt++;
	f=(c<0x30 || (0x39<c && c<0x40) || c==0x5c || c>0x7a) &&
		(( c==0x22 || c==0x24 || c==0x27 || c==0x2c || c==0x3a)==0);
	int mf=0;
	if(f){
		//黻
		type=0;
		s[0]=c; s[1]=buf[asbuf[asno].pt]; s[2]=0;
		if(ef && s[0]=='-' && s[1]>='0' && s[1]<='9'){
			mf=1;
			c=s[1];
			asbuf[asno].pt++;
		}else{
			data=c;
			if(strcmp(s,"==")==0){data='=';asbuf[asno].pt++;}
			if(strcmp(s,"!=")==0){data='!';asbuf[asno].pt++;}
			if(strcmp(s,"<=")==0){data='a';asbuf[asno].pt++;}
			if(strcmp(s,">=")==0){data='b';asbuf[asno].pt++;}
			if(strcmp(s,"<<")==0){data='c';asbuf[asno].pt++;}
			if(strcmp(s,">>")==0){data='d';asbuf[asno].pt++;}
			if(c!=')') ef=1;
			//printf("exp:%s\n",s);
			s[1]=0;
			return 1;
		}
	}
	ef=0;
	if(c==0x27){
		//'?' 
		type=1;
		data=buf[asbuf[asno].pt];
		while(1){
			if(buf[asbuf[asno].pt]==0)break;
			if(buf[asbuf[asno].pt]==0x10)break;
			if(buf[asbuf[asno].pt]==0x13)break;
			if(buf[asbuf[asno].pt]==0x27){asbuf[asno].pt++;break;}
			asbuf[asno].pt++;
		}
		return 1;
	}
	if(c=='"'){
		//ʸ
		type=2;
		data=strpt;
		char *p;
		if(flag&1){
			p=strbuf+strpt;
		}else{
			p=s;
		}
		int i=0,l=0;
		while(1){
			c=buf[asbuf[asno].pt];
			if(c==13 || c==10)break;
			asbuf[asno].pt++;
			if(winflag){
				if((unsigned char)((c^0x20)-0xA1)<=0x3B){
					p[l++]=c;
					c=buf[asbuf[asno].pt++];
				}
			}
			if(c=='"')break;
			if(c=='\\'){
				c=buf[asbuf[asno].pt++];
				if (winflag) {
					if(c=='n'){c=10;p[l++]=13;} //Win
				} else {
					if(c=='n')c=10; //Unix
				}
				if(c=='r')c=13;
				if(c=='t')c=9;
			}
			p[l]=c;
			l++;
		}
		p[l]=0;
		l++;
		if(flag&1)strpt+=l;
		return 1;
	}


	int i=1;
	if(c>='A' && c<='Z'){
		c+='a'-'A';
	}
	s[0]=c;
	while(1){
		c=buf[asbuf[asno].pt];
		if(c<=0x20)
			break;
		f=c<0x30 || (0x39<c && c<0x40) || 0x7a<c || c==0x5c;
		if(f)break;
		if(c>='A' && c<='Z'){
			c+='a'-'A';
		}
		s[i]=c;
		asbuf[asno].pt++;
		i++;
	}
	s[i]=0;
	if((s[0]>='0' && s[0]<='9') || s[0]=='$') {
		//ʿ
		type=1;
		if(s[1]=='x'){
			data=strtol(s+2,0,16);
		}else if(s[1]=='$'){
			data=strtol(s+1,0,16);
		}else{
			data=strtol(s,0,10);
		}
		if(mf) data=-data;
	}
	if(strcmp(s,"__line__")==0){
		type=1;
		data=asbuf[asno].line;
		printf("ok\n");
	}
	if(strcmp(s,"__file__")==0){
		type=2;
		printf("ok\n");
		data=strpt;
		char *p;
		if(flag&1){
			p=strbuf+strpt;
		}else{
			p=s;
		}
		sprintf(p,"%s",asbuf[asno].file);
		if(flag&1)strpt+=strlen(p);
	}

	return 1;
}

int axwrite(char *buf){
	int code=(nf<<9) | (cf<<10) | (type<<11);
	if(data&~0x1ff){
		*((short*)(buf+codept))=code|0x8000;
		*((int*)(buf+codept+2))=data;
		codept+=6;
	}else{
		*((short*)(buf+codept))=code|data;
		codept+=2;
	}
	return codept;
}

int getstr(char *s,char *buf, char c,int *p){
	int i=0;
	while(buf[i]){
		if(buf[i]==c)break;
		s[i]=buf[i];
		i++;
	}
	s[i]=0;
	c=buf[i];
	*p+=i+(buf[i]!=0);
	return (unsigned char)c;
}

TABLE tbl[4096];
int ncmd=0;
DEFINETBL deftbl[256];
#define DEFINEMAX 200
MODINFO modtbl[256];
int nmodcmd=0;
char modulename[64];

/////////////////////////////////////////////////////////////////////////////
//           ץץå
int cmpf;
int ifnest=0;
// ץץå̿
int prp(){
	char s[4096];
	gettokn(s,2);
	// ifdef
	if(strcmp(s,"ifdef")==0){
		ifnest++;
		if(cmpf)return 0;
		gettokn(s,2);
		//printf("hspcmp: ifdef '%s'\n",s);
		int i;
		for(i=0;i<DEFINEMAX;i++){
			if(deftbl[i].flag==1 && strcmp(s,deftbl[i].name)==0){
				cmpf=0;
				return 0;
			}
		}
		cmpf=ifnest;
		return 0;
	}
	// ifndef
	if(strcmp(s,"ifndef")==0){
		ifnest++;
		if(cmpf)return 0;
		gettokn(s,2);
		//printf("hspcmp: ifndef '%s'\n",s);
		int i;
		for(i=0;i<DEFINEMAX;i++){
			if(deftbl[i].flag==1 && strcmp(s,deftbl[i].name)==0){
				cmpf=ifnest;
				return 0;
			}
		}
		cmpf=0;
		return 0;
	}
	// endif
	if(strcmp(s,"endif")==0){
		if(cmpf==ifnest){
			cmpf=0;
		}
		ifnest--;
		return 0;
	}
	// endif
	if(strcmp(s,"else")==0){
		if(cmpf==0)
			cmpf=ifnest;
		else if(cmpf==ifnest)
				cmpf=0;
		return 0;
	}
	if(cmpf)return 0;
	// include
	if(strcmp(s,"include")==0){
		gettokn(s,2);
		printf("hspcmp: include '%s'\n",s);
		asno++;
		if(asbuf[asno].load(s)<0){
			printf("hspcmp: file not found :%s\n",s);
			return 1;
		}
		return 0;
	}
	// deffunc
	if(strcmp(s,"deffunc")==0){
		gettokn(s,2);
		//printf("hspcmp: deffunc '%s'\n",s);
		modtbl[nmodcmd].num=nmodcmd+0x1002;
		modtbl[nmodcmd].pt=codept>>1;
		modtbl[nmodcmd].type=0;
		modtbl[nmodcmd].prms=4;
		strcpy(tbl[ncmd].name,s);
		tbl[ncmd].flag=1;
		tbl[ncmd].type=0xC;
		tbl[ncmd].code=nmodcmd+0x10;
		int i=0;
		while(gettokn(s,2)){
			if(strcmp(s,"int")==0){
				//modtbl[nmodcmd].type+=0<<(i*4);
				i++;
			}
			if(strcmp(s,"val")==0){
				modtbl[nmodcmd].type+=1<<(i*4);
				i++;
			}
			if(strcmp(s,"str")==0){
				modtbl[nmodcmd].type+=2<<(i*4);
				i++;
			}
		}
		if(i)modtbl[nmodcmd].prms=i;
		nmodcmd++;
		ncmd++;
		return 0;
	}
	// define
	if(strcmp(s,"define")==0){
		gettokn(s,2);
		if(strcmp(s,"global")==0){
			gettokn(s,2);
		}else{
			//if(modulename[0]){
			//	strcat(s,"@");
			//	strcat(s,modulename);
			//}
		}
		//printf("hspcmp: define '%s'\n",s);
		int i;
		for(i=0;i<ncmd;i++){
			if(tbl[i].flag && strcmp(tbl[i].name,s)==0){
				printf("hspcmp: Error already existed '%s'\n",s);
				return 1;
			}
		}
		for(i=0;i<DEFINEMAX;i++){
			if(deftbl[i].flag && strcmp(deftbl[i].name,s)==0){
				printf("hspcmp: Error already existed '%s'\n",s);
				return 1;
			}
		}
		for(i=0;i<DEFINEMAX;i++){
			if(deftbl[i].flag==0){
				deftbl[i].flag=1;
				strcpy(deftbl[i].name,s);
				getlne(s);
				strcpy(deftbl[i].str,s);
				return 0;
			}
		}
		return 1;
	}
	// undef
	if(strcmp(s,"undef")==0){
		gettokn(s,2);
		//printf("hspcmp: undef '%s'\n",s);
		int i;
		for(i=0;i<DEFINEMAX;i++){
			if(deftbl[i].flag==1 && strcmp(s,deftbl[i].name)==0){
				deftbl[i].flag=0;
				return 0;
			}
		}
		return 0;
	}
	// module
	if(strcmp(s,"module")==0){
		if(gettokn(s,2))
			strcpy(modulename,s);
		else
			sprintf(modulename,"_mod%d",codept);
		printf("hspcmp: module '%s'\n",modulename);
		sprintf(s,":goto *__tail@%s",modulename);
		asno++;
		asbuf[asno].set(s);
		asbuf[asno].line=asbuf[asno-1].line;
		strcpy(asbuf[asno].file,asbuf[asno-1].file);
		return 0;
	}
	// global
	if(strcmp(s,"global")==0){
		//printf("hspcmp: module end '%s'\n",modulename);
		sprintf(s,":*__tail@%s",modulename);
		asno++;
		asbuf[asno].set(s);
		asbuf[asno].line=asbuf[asno-1].line;
		strcpy(asbuf[asno].file,asbuf[asno-1].file);
		modulename[0]='\0';
		return 0;
	}
	printf("hspcmp: unknow command :%s\n",s);
	return 1;
}

// ץץå̿2 define module
int prp2(char *s){
	int i,l;
	for(i=0;i<DEFINEMAX;i++){
		if(deftbl[i].flag && strcmp(s,deftbl[i].name)==0){
			asno++;
			asbuf[asno].pt=0;
			asbuf[asno].len=strlen(deftbl[i].str);
			asbuf[asno].buf=(unsigned char*)deftbl[i].str;
			asbuf[asno].line=asbuf[asno-1].line;
			strcpy(asbuf[asno].file,asbuf[asno-1].file);
			return 1;
		}
	}
	l=strlen(s);

	// Ǹ@ϼ
	if(s[l-1]=='@'){
		s[l-1]='\0';
		return 0;
	}

	if(!modulename[0]) return 0;

	//Ǥ@դƤ뤫
	for (i=0;i<l;i++) {
		if (s[i]=='@') {
			return 0;
		}
	}

	// ɸ̿ᤫ
	if (modulename[0]) {
		for(i=0;i<ncmd;i++){
			if(tbl[i].flag && strcmp(tbl[i].name,s)==0){
				return 0;
			}
		}
	}
	// ⥸塼̾Ĥ
	s[l]='@';
	strcpy(s+l+1,modulename);
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//           ᥤ
int main(int argc, char *argv[], char *envp[]){
	char ifile[512];
	char ofile[512];

	ifile[0]=0;
	strcpy(ofile,"start.ax");

	printf("HSP Compiler Ver. 0.3d  (c) K-K 2003-2005\n");
	if(argc<=1){
		printf("usage: %s [-g ][-win ][-o outputfile] asfile\n",argv[0]);
		return 0;
	}
	int i=0,p=0;

	int mode=0;
	i=1;
	while(i<argc){
		if(argv[i][0]=='-'){
			if(argv[i][1]=='g'){
				debugflag=1;
				mode=0;
			}else if(argv[i][1]=='w'){
				winflag=1;
				mode=0;
			}else{
				mode=argv[i][1];
			}
		}else{
			//printf("%s\n",argv[i]);
			switch(mode){
			case 0:
				strcpy(ifile,argv[i]);
				break;
			case 'o':
				strcpy(ofile,argv[i]);
				mode=0;
				break;
			}
		}
		i++;
	}


	memset(tbl,0,sizeof(TABLE)*4096);
	int p2;p=0;
	char s[4096],ts[24];
	int typ;
	int k;
	int err=0;
	i=0;
	while(i< sizeof(cmdlist)/sizeof(CMDINFO)){
		if(strcmp(cmdlist[i].cmd,"---")==0){
			typ=cmdlist[i].code;
			i++;
			continue;
		}
		tbl[ncmd].flag=1;
		tbl[ncmd].type=typ;
		tbl[ncmd].code=cmdlist[i].code;
		strcpy(s,cmdlist[i].cmd);

		p2=0;
		if(getstr(tbl[ncmd].name,s,' ',&p2)){
			k=0;
			while(k<8){
				int st=getstr(ts,s+p2,',',&p2);
				if(strcmp(ts,"label")==0){
					tbl[ncmd].prmtyp[k]=1;
				}
				k++;
				if(st==0)break;
			}
		}
		//printf("%d %d:%s\n",tbl[ncmd].type,tbl[ncmd].code,tbl[ncmd].name);
		ncmd++;
		i++;
	}

	strbuf=(char*)malloc(1024000);
	strpt=0;

	char* codebuf=(char*)malloc(1024000);
	codept=0;

	dbgbuf=(unsigned char*)malloc(1024000);
	dbgpt=0;
	if(debugflag==0)
		dbgbuf[dbgpt]=0xFF;
	dbgpt++;

	if(asbuf[asno].load(ifile)<0){
		printf("hspcmp: file not found :%s\n",ifile);
		free(strbuf);
		free(dbgbuf);
		free(codebuf);
		return 1;
	}


	int label[1024];
	int nval=0,nlabel=1;
	int ifnest=0,looplv=0;
	int loop_pt[64];
	int ifpt[64];
	int ifmode[64];
	int valf=0;
	modulename[0]='\0';
	cmpf=0;
	kf=0;


	while(gettokn(s,1)){
		// ץץå
		if(type==0 && data=='#'){
			if(prp()) return 1;
			cf=0;
			nlf=0;
			continue;
		}
		if(cmpf)
			continue;
		if(type<0){
			if(prp2(s))
				continue;
		}

		if(ifnest){
			if(strcmp(s,"else")==0) nlf=kf==0;
			if(strcmp(s,"{")==0) ifmode[ifnest]=1;
			kf=s[0]=='}';
			for(i=0;i<ifnest;i++){
				if((ifmode[ifnest]!=0) & kf ){
					nlf=1;
					kf=0;
					ifmode[ifnest]=0;
				}
				if((ifmode[ifnest]==0) & nlf ){
					*(short*)(codebuf+ifpt[ifnest])=((codept-ifpt[ifnest])>>1)-1;
					ifnest--;
					i--;
				}
			}
		}
		kf=0;
		if(s[0]=='{' || s[0]=='}'){kf=1;continue;}

		if(type<0){
			// ɸ̿ᡦ桼̿
			for(i=0;i<ncmd;i++){
				if(strcmp(tbl[i].name,s)==0){
					type=tbl[i].type;
					data=tbl[i].code;
					if(nf && (type==8 || type==9))
						acmd=i;
					break;
				}
			}
		}
		if(type<0){
			if(acmd>=0 && prmm<8){
				if(tbl[acmd].prmtyp[prmm]==1)
					lf=2;
			}
			if(lf){
				data=nlabel;
				nlabel++;
				type=3;
			}else{
				data=nval;
				nval++;
				type=4;
			}
			tbl[ncmd].code=data;
			tbl[ncmd].type=type;
			strcpy(tbl[ncmd].name,s);
			ncmd++;
		}
		//printf("debug: Line:%d %s(%d) prm:%d %d %d\n",asbuf[asno].line,s,type,prmm,cf,nf);
		if(valf && type!=0){
			printf("hspcmp: Syntax error line:%d\n",asbuf[asno].line);
			err=2;
		}
		valf=0;
		if(type==3 && lf==1){
			label[data]=codept>>1;
		}
		if(type==4){
			if(nf)valf=1;
		}
		if(lf==1){
			continue;
		}
		if(type<0){
			printf("hspcmp: Error %s:%d  %s",asbuf[asno].file,asbuf[asno].line,s);
			free(strbuf);
			free(dbgbuf);
			free(codebuf);
			exit(1);
		}
		axwrite(codebuf);

		if(type==8 && data==0x11){//repeat
			looplv++;
			loop_pt[looplv]=nlabel;
			nf=1;
			cf=0;
			type=3;
			data=nlabel;
			axwrite(codebuf);
			nlabel++;
		}
		if (type==8 && (data==0x3 || data==0x2b)){//break,continue
			data=loop_pt[looplv];
			nf=1;
			cf=0;
			type=3;
			axwrite(codebuf);
		}
		if(type==8 && data==0x12) {//loop
			label[loop_pt[looplv]]=codept>>1;
			looplv--;
		}
		if(type==0xB){//if,else
			ifnest++;
			if(data==1){
				*(short*)(codebuf+ifpt[ifnest])=(codept-ifpt[ifnest])>>1;
			}
			ifpt[ifnest]=codept;
			ifmode[ifnest]=0;
			codept+=2;
		}
		cf=0;
		//printf("%d:%d %d '%s'\n",prmm,data,type,s);
		//usleep(100);
	}

	if(ifnest){
		printf("hspcmp: error '{' - '}'\n");
		return 1;
	}

	if(debugflag){
		int i,j=0;
		for(i=0;i<ncmd;i++){
			if(tbl[i].type==4){
				dbgbuf[dbgpt]=0xFD;
				dbgbuf[dbgpt+1]=strpt;
				dbgbuf[dbgpt+2]=strpt>>8;
				dbgbuf[dbgpt+3]=strpt>>16;
				dbgbuf[dbgpt+4]=j;
				dbgbuf[dbgpt+5]=j>>8;
				dbgpt+=6;
				strcpy(strbuf+strpt,tbl[i].name);
				strpt+=strlen(tbl[i].name)+1;
				j++;
			}
		}
	}

	dbgbuf[dbgpt]=0xFF;
	dbgpt++;
	//AXեإå
	AXHEAD head;
	memset(&head,0,sizeof(AXHEAD));
	memcpy(head.sig,"HSP2",4);
	head.version=0x255;
	head.valcnt=nval;
	p=0;
	p+=sizeof(AXHEAD);
	head.code_start=p;
	head.code_size=codept;
	p+=codept;
	head.str_start=p;
	head.str_size=strpt;
	p+=strpt;
	head.label_start=p;
	head.label_size=nlabel*4;
	p+=nlabel*4;
	head.debug_start=p;
	head.debug_size=dbgpt;
	p+=dbgpt;
/*
	head.dlllst_start=p;
	head.dlllst_size=0;
	head.dllc_start=p;
	head.dllc_size=0;
*/
	head.mod_start=p;
	head.mod_size=nmodcmd*sizeof(MODINFO);
	p+=nmodcmd*sizeof(MODINFO);

	head.file_size=p;

	FILE *fp=fopen(ofile,"wb");

	fwrite(&head,1,sizeof(AXHEAD),fp);
	fwrite(codebuf,1,codept,fp);
	fwrite(strbuf,1,strpt,fp);
	fwrite(label,1,nlabel*4,fp);
	fwrite(dbgbuf,1,dbgpt,fp);
	fwrite(modtbl,1,head.mod_size,fp);

	fclose(fp);

	free(strbuf);
	free(dbgbuf);
	free(codebuf);

	printf("hspcmp: code size: %d  string data size: %d \n",codept,strpt);
	printf("hspcmp: debug data size: %d\n",dbgpt);
	printf("hspcmp: num of val: %d  labels: %d \n",nval,nlabel);
	printf("hspcmp: OK. %s\n",ofile);
	return err;
}


