
#include <stdio.h>
#include "xhsp.h"

#ifdef _WIN32
#include <windows.h>
#include <conio.h> // for getkey
#else
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <termios.h> // for getkey
#include <errno.h> // for getkey
#endif



#ifdef _WIN32 // 02.11.28
HANDLE hStdOut=NULL;
CONSOLE_SCREEN_BUFFER_INFO ConInfo;
#endif

int excmd_init(int argc, char *argv[], char *envp[])
{
#ifdef _WIN32
	hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo( hStdOut, &ConInfo );
#endif
	return 0;
}

int excmd_end()
{
	return 0;
}

////////////////////////////////////////////////////////////////////////
//		HSPؿ

int hs_mes(){
	if(prmm[0].type==2){
		printf(prmm[0].s);
	}else{
		printf("%d",prmm[0].i);
	}
	if(prmm[1].type!=1){
		printf("\n");
	}
	return 0;
}


int hs_input(){
	//ax.pt+=getprm(0x01004,ax.code+ax.pt,&ax);
	if(prmm[0].type==0x14){
		char ch;
		int i=0;
		sval.stat=0;
		sval.strsize=0;
		while((ch = getchar()) && (ch != '\n')){
			if(ch==EOF){sval.stat=1;break;}
			if(i < prmm[3].i)prmm[0].pStr[i++] = ch;
			sval.strsize++;
		}
		prmm[0].pStr[i] = 0;
	}
	if(prmm[0].type==0x4){
		char s[24];
		char ch;
		int i=0;
		while((ch = getchar())  && (ch != '\n')){
			if(ch==EOF){sval.stat=1;break;}
			if(i < 24)s[i++] = ch;
		}
		prmm[0].pInt[0]=atoi(s);
	}
	return 0;
}


#ifdef _WIN32
int hs_wait(){
	Sleep(prmm[0].i*10);
	return 0;
}
int hs_await(){
	Sleep(prmm[0].i);
	return 0;
}

int hs_stop(){
	Sleep(INFINITE);
	return 0;
}

//int hs_mkdir(){
//	//ax.pt+=getprm(0x00002,ax.code+ax.pt,&ax);
//	if(prmm[0].type==2){
//		mkdir(prmm[0].s);
//	}
//	return 0;
//}
int hs_getkey(){
	prmm[0].pInt[0]=(kbhit() ?getch() : 0 );
	return 0;
}

int hs_cls(){
	COORD  pos = { 0 , 0 } ;
	DWORD l = ConInfo.dwSize.X * ConInfo.dwSize.Y ;
	if(FillConsoleOutputCharacter(hStdOut, ' ', l, pos, &l ) == 0 ) return 0;
	SetConsoleTextAttribute( hStdOut , 7 ) ;
	FillConsoleOutputAttribute( hStdOut, 7, l, pos, &l ) ;
	return 0;
}

int hs_pos(){
	if(prmm[0].i<0){
        CONSOLE_CURSOR_INFO cur;
        GetConsoleCursorInfo(hStdOut, &cur);
        cur.bVisible = FALSE;
        SetConsoleCursorInfo(hStdOut, &cur);
	}else{
		COORD pos = { prmm[0].i ,  prmm[1].i } ;
		SetConsoleCursorPosition(hStdOut, pos );
	}
	return 0;
}

int hs_color(){
	//int c= prmm[0].i + (prmm[1].i<<4); // BGR > RGB?
	int c= (prmm[0].i>>2&1) + (prmm[0].i&2) + (prmm[0].i<<2&4) + (prmm[0].i&8)
		+ (((prmm[1].i>>2&1) + (prmm[1].i&2) + (prmm[1].i<<2&4) + (prmm[1].i&8))<<4);
	SetConsoleTextAttribute(hStdOut , c  ) ;
	return 0;
}

#else
int hs_wait(){
	usleep(prmm[0].i*10000);
	return 0;
}
int hs_await(){
	usleep(prmm[0].i*1000);
	return 0;
}
int hs_stop(){
	while(true)sleep(3600);
	return 0;
}

//void hs_mkdir(){
//	//ax.pt+=getprm(0x00002,ax.code+ax.pt,&ax);
//	if(prmm[0].type==2){
//		mkdir(prmm[0].s,S_IRWXU | S_IRWXG | S_IRWXO);
//	}
//}

int nchars = 0;
unsigned char pbbuf[10];
extern int errno;
int kbhit(){
	unsigned char c;
	int n;
	struct termios old, newt;
	if(nchars > 0){
		// ɤᤵ줿Ϥ
		return 1;
	}
	//꡼ɡޡꤹ
	tcgetattr(0, &old);
	newt = old;
	newt.c_lflag &= ~ICANON;
	newt.c_cc[VMIN] = 0;
	newt.c_cc[VTIME] = 0; // 0
	tcsetattr(0, TCSADRAIN, &newt);
	// Ϥɤ
	while ((n = read(0, &c, 1)) < 0 && errno == EINTR)
	;
	// ꡼ɡޡ
	tcsetattr(0, TCSADRAIN, &old);
	if (n == 1) {
		// Ϥɤ᤹
		pbbuf[nchars++]=c;
		return 1;
	}
	return 0;
}

int getch(){
	unsigned char c;
	int n;
	if (nchars > 0)
		return pbbuf[--nchars];
	while ((n = read(0, &c, 1)) < 0 && errno == EINTR)
	;
	if (n == 0)
		return -1;
	return (int)c;
}

int hs_getkey(){
	prmm[0].pInt[0]=(kbhit() ?getch():0 );
	//prmm[0].pInt[0]=getchar();
	return 0;
}
int hs_cls(){
	printf( "\x1b[2J" );
	return 0;
}

int hs_pos(){
	if(prmm[0].i<0){
		printf( "\x1b[5>h" );
	}else{
		printf( "\x1b[%d;%dH" , prmm[1].i+1 , prmm[0].i+1 );
	}
	return 0;
}

int hs_color(){
	printf( "\x1b[%d;%dm" , prmm[0].i>>3&1,(prmm[0].i&7)+30 );
	if(prms>1)printf( "\x1b[%d;%dm" , (prmm[1].i>>3&1)^1,(prmm[1].i&7)+40 );
	if(prms>2)printf( "\x1b[%dm" , prmm[3].i );
	return 0;
}
#endif

void gui_getWinsize(int *x,int *y)
{
	*x=0;
	*y=0;
}
 
void gui_getCurrentPos(int *x,int *y)
{
	*x=0;
	*y=0;
}

void gui_getPointer(int *x,int *y)
{
	*x=0;
	*y=0;
}

////////////////////////////////////////////////////////////////////////

int excmd_list(FUNCINFO* hs_func,int size)
{
//*

	//0x40xx
	hs_func[0x10].func=hs_wait;
	hs_func[0x10].ptyp=0x00001;
	hs_func[0x13].func=hs_mes;
	hs_func[0x13].ptyp=0x00000;
	hs_func[0x1a].func=hs_stop;
	hs_func[0x1a].ptyp=0x00000;
	hs_func[0x21].func=hs_await;
	hs_func[0x21].ptyp=0x00001;
	//0x48xx
	hs_func[0x11|0x80].func=hs_pos;
	hs_func[0x11|0x80].ptyp=0x00011;
	hs_func[0x13|0x80].func=hs_cls;
	hs_func[0x13|0x80].ptyp=0x00011;
	hs_func[0x18|0x80].func=hs_color;
	hs_func[0x18|0x80].ptyp=0x00111;
	hs_func[0x23|0x80].func=hs_getkey;
	hs_func[0x23|0x80].ptyp=0x00118;
	hs_func[0x27|0x80].func=hs_input;
	hs_func[0x27|0x80].ptyp=0x01118;
	//hs_func[0x2e|0x80].func=hs_exec;
	//hs_func[0x2e|0x80].ptyp=0x00012;
	//hs_func[0x38|0x80].func=hs_randomize;
	//hs_func[0x38|0x80].ptyp=0x00001;
	//hs_func[0x2f|0x80].func=hs_mkdir;
	//hs_func[0x2f|0x80].ptyp=0x00002;
	//hs_func[0x3f|0x80].func=hs_chdir;
	//hs_func[0x3f|0x80].ptyp=0x00002;
//*/
	return 0;
}

