//		HSP 󥿥ץ꥿
//


#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h> //UNIX
#include <sys/stat.h>
#include <termios.h> // for getkey
#include <errno.h> // for getkey
#include <stdio.h>

#include "xhsp.h"

int eventflag;

///////////////  X window GUI ///////////////////////////////
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#define MAXWINDOW 1024

Display *display; // global(^^;
int g_argc;
char **g_argv;

XFontStruct *font1,*font2;
int fs=14;

unsigned long _getcolor(int col){
	Colormap cmap;
	XColor c0,c;
	cmap = DefaultColormap(display,0);
	c.red = ((col>>16)&0xff)*257;
	c.green = ((col>>8)&0xff)*257;
	c.blue = (col&0xff)*257;
	c.flags = DoRed|DoGreen|DoBlue;
	XAllocColor(display, cmap, &c);

	return c.pixel;
}

int _getline(char *s,int l){
	int c=0,i=0;
	while(s[c]!=0 && i<l){
		if(s[c]==10){
			i++;
		}
		c++;
	}
	return c;
}

struct WND{
	Window wnd;
	int sx,sy;
	GC gc;
	int style;
	WND* parent;
	int fs; //font size
	int dat[2];
};
typedef WND *HWND;

struct _HWND_Window{
	HWND hWnd;
	Window win;
};

_HWND_Window _hwnd_wnd[MAXWINDOW];

struct _DC{
//	HWND hWnd;
	Drawable d,d2;
	GC gc;
	int cx,cy;
	int txtcolor;
	int mode;
};
typedef _DC *HDC;

HWND _win2hwnd(Window win){
	int i;
	for(i=0;i<MAXWINDOW;i++){
		if(_hwnd_wnd[i].win==win){
			return _hwnd_wnd[i].hWnd;
		}
	}
	return NULL;
}

HWND CreateWindow(char *cname, char *wname, long style,
					int x,int y,int sx,int sy,HWND parent){
	Window pw;
	HWND hWnd=(HWND)malloc(sizeof(WND));
	memset(hWnd,0,sizeof(WND));
	hWnd->sx = sx;
	hWnd->sy = sy;
	hWnd->style=style;
	if(parent){
		pw=parent->wnd;
		hWnd->parent=parent;
	}else{
		pw=DefaultRootWindow(display);
		hWnd->parent=NULL;
	}
	if(style>=10){
		hWnd->wnd = XCreateSimpleWindow(display,pw,
				x,y,sx,sy, 0,0,_getcolor(0xdddddd));
	}else{
		hWnd->wnd = XCreateSimpleWindow(display,pw,
					x,y,sx,sy, 0,0,WhitePixel(display,0));
	}
	XSetStandardProperties(display,hWnd->wnd,wname,cname,
				None,g_argv,g_argc,NULL);
	hWnd->gc = XCreateGC(display,hWnd->wnd,0,0);
	XSetBackground(display,hWnd->gc,WhitePixel(display,0));
	XSetForeground(display,hWnd->gc,BlackPixel(display,0));
	int i;
	for(i=0;i<MAXWINDOW;i++){
		if(_hwnd_wnd[i].hWnd==NULL){
			_hwnd_wnd[i].hWnd=hWnd;
			_hwnd_wnd[i].win=hWnd->wnd;
			break;
		}
	}
	return hWnd;
}

void DeleteWindow(HWND hWnd){
	int i;
	for(i=0;i<MAXWINDOW;i++){
		if(_hwnd_wnd[i].hWnd==hWnd){
			_hwnd_wnd[i].hWnd=NULL;
			_hwnd_wnd[i].win=0;
			break;
		}
	}
	XDestroyWindow(display, hWnd->wnd);
	free(hWnd);
}

void SetWindowText(HWND hWnd,char *name){
	XStoreName(display,hWnd->wnd,name);
}

char* GetWindowText(HWND hWnd){
	char *s;
	XFetchName(display,hWnd->wnd,&s);
	return s;
}

void ShowWindow(HWND hWnd,int nCmdShow){
	if(nCmdShow){
		if(hWnd->parent)
			XMapSubwindows(display,hWnd->parent->wnd);
		else
			XMapRaised(display,hWnd->wnd);
	}else{
		if(hWnd->parent)
			XUnmapSubwindows(display,hWnd->parent->wnd);
		else
			XUnmapWindow(display,hWnd->wnd);
	}
}

HDC GetDC(HWND hWnd){
	HDC hDC=(HDC)malloc(sizeof(_DC));
//	hDC->hWnd=hWnd;
	hDC->d=hWnd->wnd;
	hDC->gc = XCreateGC(display,hDC->d,0,0);
	XSetBackground(display,hDC->gc,WhitePixel(display,0));
	XSetForeground(display,hDC->gc,BlackPixel(display,0));
	hDC->txtcolor=0;
	hDC->cx=0;
	hDC->cy=0;
	hDC->mode=0;
	return hDC;
}

HDC GetDC2(HWND hWnd,Drawable d){
	HDC hDC=(HDC)malloc(sizeof(_DC));
//	hDC->hWnd=hWnd;
	hDC->d=hWnd->wnd;
	hDC->d2=d;
	hDC->gc = XCreateGC(display,hDC->d,0,0);
	XSetBackground(display,hDC->gc,WhitePixel(display,0));
	XSetForeground(display,hDC->gc,BlackPixel(display,0));
	hDC->txtcolor=0;
	hDC->cx=0;
	hDC->cy=0;
	hDC->mode=1;
	return hDC;
}

/*
HDC CreatePixmapDC(int x,int y){
	HDC hDC=(HDC)malloc(sizeof(_DC));
//	hDC->d=XCreatePixmap(display,bms->hWnd->wnd,x,y,
//				DefaultDepth(display,0));
	hDC->gc = XCreateGC(display,hDC->d,0,0);
	XSetBackground(display,hDC->gc,WhitePixel(display,0));
	XSetForeground(display,hDC->gc,BlackPixel(display,0));
	hDC->cx=0;
	hDC->cy=0;
	hDC->mode=2;
	return hDC;
}

int DeletePixmapDC(HDC hDC){
	XFreePixmap(display, hDC->d);
	return true;
}
*/

int ReleaseDC(HDC hDC){
	free(hDC);
	return true;
}
int SetTextColor(HDC hDC,int c){
	int cc=hDC->txtcolor;
	hDC->txtcolor=c;
	Colormap cmap;
	XColor c1;
	cmap = DefaultColormap(display,0);

	c1.red = ((c>>16)&0xff)*257;
	c1.green = ((c>>8)&0xff)*257;
	c1.blue = (c&0xff)*257;
	c1.flags = DoRed|DoGreen|DoBlue;
	XAllocColor(display, cmap, &c1);

	XSetForeground(display,hDC->gc,c1.pixel);
	return cc;
}
int MoveTo(HDC hDC,int x,int y){
	hDC->cx=x;
	hDC->cy=y;
	return true;
}

int LineTo(HDC hDC,int x,int y){
	XDrawLine(display,hDC->d,hDC->gc,
				hDC->cx,hDC->cy, x , y);
	if(hDC->mode){
		XDrawLine(display,hDC->d2,hDC->gc,
					hDC->cx,hDC->cy, x , y);
	}
	hDC->cx=x;
	hDC->cy=y;
	return true;
}

int DrawPoint(HDC hDC,int x,int y){
	XDrawPoint(display, hDC->d, hDC->gc,  x, y);
	if(hDC->mode){
		XDrawPoint(display, hDC->d2, hDC->gc,  x, y);
	}
	return true;
}

int Rectangle(HDC hDC, int x1,int y1, int x2,int y2){
	XFillRectangle(display,hDC->d,hDC->gc,x1,y1,x2-x1,y2-y1);
	if(hDC->mode){
		XFillRectangle(display,hDC->d2,hDC->gc,x1,y1,x2-x1,y2-y1);
	}
	return true;
}

int DrawEdge(HDC hDC, int x1,int y1, int x2,int y2, int f){
	int c;
	if(f){
		c=SetTextColor(hDC,0x888888);
	}else{
		c=SetTextColor(hDC,0xeeeeee);
	}
	// |~~~
	MoveTo(hDC,x1  ,y2-1);
	LineTo(hDC,x1  ,y1  );
	LineTo(hDC,x2-1,y1  );
	MoveTo(hDC,x1+1,y2-2);
	LineTo(hDC,x1+1,y1+1);
	LineTo(hDC,x2-2,y1+1);
	if(f){
		SetTextColor(hDC,0xeeeeee);
	}else{
		SetTextColor(hDC,0x888888);
	}
	// ___|
	MoveTo(hDC,x1  ,y2-1);
	LineTo(hDC,x2-1,y2-1);
	LineTo(hDC,x2-1,y1  );
	MoveTo(hDC,x1+1,y2-2);
	LineTo(hDC,x2-2,y2-2);
	LineTo(hDC,x2-2,y1+1);

	SetTextColor(hDC,c);
	return true;
}

int TextOut(HDC hDC,int x,int y,char *ss,int l){
	static char s[1024];
	strcpy(s,ss);
	y+=fs;
	int i=0,j=0,f=0,cf;
	do{
		if(s[i]&0x80){
			s[i]&=0x7f;
			cf=f==0;
		}else{
			cf=f==1;
		}
		if(cf || (s[i]==0) ){
			//printf("%d:%s %d + %d\n",f,s+j,j,i-j);
			if(f==0){
				XSetFont(display, hDC->gc, font1->fid);
				XDrawString(display,hDC->d,hDC->gc,
					x,y,s+j,i-j);
				if(hDC->mode){
					XDrawString(display,hDC->d2,hDC->gc,
						x,y,s+j,i-j);
				}
				x+=(i-j)*fs>>1;
			}else{
				XSetFont(display, hDC->gc, font2->fid);
				XDrawString16(display,hDC->d,hDC->gc,
					x,y,(XChar2b*)(s+j),(i-j)>>1);
				if(hDC->mode){
					XDrawString16(display,hDC->d2,hDC->gc,
						x,y,(XChar2b*)(s+j),(i-j)>>1);
				}
				x+=(i-j)*fs>>1;
			}
			j=i;
			f^=1;
		}
	}while(s[i++]);
	return true;
}
/////////////////////////////////////////////////////////////////////////////


#define MAXBMSCR 32
#define objkazz 32


//char *exefile;


struct BMSCR{
	HWND hWnd;
	Pixmap pix;
	HDC hDC;
	int sx,sy;
	int curx,cury;
	int objw,objh;
	int objs;
	HWND obj[objkazz];
	long objd[objkazz];
};

void HSP_InitBMS(BMSCR *bms,int sx,int sy)
{
	bms->sx=sx;
	bms->sy=sy;
	bms->curx=0;
	bms->cury=0;
	bms->objw=64;
	bms->objh=24;
	bms->objs=0;

	bms->hWnd=CreateWindow("xHSP","xHSP Ver.0.0",0,0,0,sx,sy,NULL);
	bms->pix = XCreatePixmap(display,bms->hWnd->wnd,sx,sy,
				DefaultDepth(display,0));
	bms->hDC=GetDC2(bms->hWnd,bms->pix);
	SetTextColor(bms->hDC,0xffffff);
	Rectangle(bms->hDC,0,0,sx,sy);
	SetTextColor(bms->hDC,0x0);
}

void HSP_FreeBMS(BMSCR *bms){
	ReleaseDC(bms->hDC);
	DeleteWindow(bms->hWnd);
	XFreePixmap(display, bms->pix);
}


BMSCR *bmscr[MAXBMSCR];
BMSCR *bms1;


void ObjWndEvent(XEvent *eve, int wid, int id){
	static char str[1024];
	HWND hWnd=bmscr[wid]->obj[id];
	char *s;
	if(hWnd->style==10){//button
		switch( eve->type ){
		case Expose:
			{
			s=GetWindowText(hWnd);
			HDC hDC=GetDC(hWnd);
			DrawEdge(hDC,0,0,
				hWnd->sx,hWnd->sy,0);
			TextOut(hDC,10,(hWnd->sy-fs)>>1,s,0);
			ReleaseDC(hDC);
			XFree(s);
			}
			break;
		case ButtonPress:
			{
			HDC hDC=GetDC(hWnd);
			DrawEdge(hDC,0,0,
				hWnd->sx,hWnd->sy,1);
			ReleaseDC(hDC);
			}
			break;
		case ButtonRelease:
			{
			HDC hDC=GetDC(hWnd);
			DrawEdge(hDC,0,0,
				hWnd->sx,hWnd->sy,0);
			ReleaseDC(hDC);
			}
			if(eve->xbutton.x<0 || eve->xbutton.x>hWnd->sx ||
				eve->xbutton.y<0 || eve->xbutton.y>hWnd->sy){
				break;
			}
			hsinfo.pt=bmscr[wid]->objd[id];
			eventflag=1;
			break;
		}
	}else if(hWnd->style==11){//chkbox
		switch( eve->type ){
		case Expose:
			{
			HDC hDC=GetDC(hWnd);
			s=GetWindowText(hWnd);
			TextOut(hDC,20,(bmscr[wid]->obj[id]->sy-fs)>>1,s,0);
			XFree(s);
			DrawEdge(hDC,2,(bmscr[wid]->obj[id]->sy-14)>>1,
				16,(bmscr[wid]->obj[id]->sy+14)>>1,1);
			int c;
			c=SetTextColor(hDC,0xffffff);
			Rectangle(hDC,5,(bmscr[wid]->obj[id]->sy-8)>>1,
				13,(bmscr[wid]->obj[id]->sy+8)>>1);
			if(hsinfo.vallist[bmscr[wid]->objd[id]].pInt[0]){
				SetTextColor(hDC,0x0000ff);
			}else{
				SetTextColor(hDC,0xffffff);
			}
			Rectangle(hDC,7,(bmscr[wid]->obj[id]->sy-4)>>1,
				11,(bmscr[wid]->obj[id]->sy+4)>>1);
			SetTextColor(hDC,c);
			ReleaseDC(hDC);
			}
			break;
		case ButtonRelease:
			{
			if(eve->xbutton.x<0 || eve->xbutton.x>bmscr[wid]->obj[id]->sx ||
				eve->xbutton.y<0 || eve->xbutton.y>bmscr[wid]->obj[id]->sy){
				break;
			}
			HDC hDC=GetDC(bmscr[wid]->obj[id]);
			hsinfo.vallist[bmscr[wid]->objd[id]].pInt[0]=hsinfo.vallist[bmscr[wid]->objd[id]].pInt[0]==0;
			int c;
			if(hsinfo.vallist[bmscr[wid]->objd[id]].pInt[0]){
				SetTextColor(hDC,0x0000ff);
			}else{
				SetTextColor(hDC,0xffffff);
			}
			Rectangle(hDC,7,(bmscr[wid]->obj[id]->sy-4)>>1,
				11,(bmscr[wid]->obj[id]->sy+4)>>1);
			SetTextColor(hDC,c);
			ReleaseDC(hDC);
			}
			break;
		}
	}else if(hWnd->style==12){//input
		switch( eve->type ){
		case Expose:
		{
			HDC hDC=GetDC(hWnd);
			DrawEdge(hDC,0,0,
				hWnd->sx,hWnd->sy,1);
			int c=SetTextColor(hDC,0xffffff);
			Rectangle(hDC,3,3,
				hWnd->sx-3,hWnd->sy-3);
			SetTextColor(hDC,c);
			//s=GetWindowText(hWnd);
			s=(char*)bmscr[wid]->objd[id];
			TextOut(hDC,6,(bmscr[wid]->obj[id]->sy-fs)>>1,s,0);
			//XFree(s);
			MoveTo(hDC,bmscr[wid]->obj[id]->dat[0]*fs/2+6,3);
			LineTo(hDC,bmscr[wid]->obj[id]->dat[0]*fs/2+6,bmscr[wid]->obj[id]->sy-4);
			ReleaseDC(hDC);
		}
			break;
		case KeyPress:
		{
			HDC hDC=GetDC(bmscr[wid]->obj[id]);
			s=(char*)bmscr[wid]->objd[id];
			int i,a;
			KeySym k;
			int l=strlen(s);
			i=XLookupString((XKeyEvent*)eve,str,16,&k,NULL);
			switch(k){
			case XK_Left:
				if(bmscr[wid]->obj[id]->dat[0]>0){
					bmscr[wid]->obj[id]->dat[0]-=1;
				}
				break;
			case XK_Right:
				if(bmscr[wid]->obj[id]->dat[0]<l){
					bmscr[wid]->obj[id]->dat[0]+=1;
				}
				break;
			case XK_BackSpace:
				if(bmscr[wid]->obj[id]->dat[0]>0){
					strcpy(s+bmscr[wid]->obj[id]->dat[0]-1,
						s+bmscr[wid]->obj[id]->dat[0]);
					bmscr[wid]->obj[id]->dat[0]-=1;
				}
				break;
			case XK_Delete:
				if(bmscr[wid]->obj[id]->dat[0]<l){
					strcpy(s+bmscr[wid]->obj[id]->dat[0],
						s+bmscr[wid]->obj[id]->dat[0]+1);
				}
				break;
			default:
				if((unsigned char)str[0]<32){
					//printf("%d\n",k);
				}else{
					//printf("%d\n",str[0]);
					strcpy(str+i,s+bmscr[wid]->obj[id]->dat[0]);
					strcpy(s+bmscr[wid]->obj[id]->dat[0],str);
					bmscr[wid]->obj[id]->dat[0]+=i;
				}
			}

			int c=SetTextColor(hDC,0xffffff);
			Rectangle(hDC,3,3,
				bmscr[wid]->obj[id]->sx-3,bmscr[wid]->obj[id]->sy-3);
			SetTextColor(hDC,c);
			//s=GetWindowText(bmscr[wid]->obj[id]);
			s=(char*)bmscr[wid]->objd[id];
			TextOut(hDC,6,(bmscr[wid]->obj[id]->sy-fs)>>1,s,0);
			MoveTo(hDC,bmscr[wid]->obj[id]->dat[0]*fs/2+6,3);
			LineTo(hDC,bmscr[wid]->obj[id]->dat[0]*fs/2+6,bmscr[wid]->obj[id]->sy-4);


			ReleaseDC(hDC);
		}
			break;
		}
	}

}

int MainWndEvent(XEvent *eve,BMSCR *bms){
	switch( eve->type ){
	case Expose:
		XCopyArea(display, bms->pix, bms->hWnd->wnd, bms->hWnd->gc,
				0, 0, bms->sx, bms->sy,
				0, 0);
		//XFlush( display );
		break;
	case MotionNotify:
		sval.mousex=eve->xmotion.x;
		sval.mousey=eve->xmotion.y;
		break;
	case ButtonPress:
		sval.mbutton[eve->xbutton.button^(eve->xbutton.button>>1&1)]=1;
		break;
	case ButtonRelease:
		sval.mbutton[eve->xbutton.button^(eve->xbutton.button>>1&1)]=0;
		break;
	default:
		break;
	}
	return 0;
}

int KEventChk(){
	static XEvent eve;
	eventflag=0;
	while(XEventsQueued( display, QueuedAfterFlush)>0){
		//if(XFilterEvent(&eve, 0))return 0;
		XNextEvent(display,&eve);
		HWND hWnd=_win2hwnd(eve.xany.window);
		if(hWnd==NULL)
			break;

		int id;
		for(id=0;id<MAXBMSCR;id++){
			if(!bmscr[id])continue;
			if(hWnd==bmscr[id]->hWnd){
				MainWndEvent(&eve,bmscr[id]);
				break;
			}
			if(hWnd->parent==bmscr[id]->hWnd){
				int i;
				for(i=0;i<bmscr[id]->objs;i++){
					if(hWnd==bmscr[id]->obj[i]){
						ObjWndEvent(&eve,id,i);
						break;
					}
				}
				break;
			}
		}

	}
	return 0;
}




////////////////////////////////////////////////////////////////////////
//		HSPؿ


int hs_wait(){
	//usleep(prmm[0].i*10000);
	int w=prmm[0].i*10000;
	timeval time1,time2;
	gettimeofday( &time1,  NULL );
	while(1){
		KEventChk();
		gettimeofday( &time2,  NULL );
		if((time2.tv_sec-time1.tv_sec)*1000000
			+time2.tv_usec-time1.tv_usec  >= w){
			break;
		}
		usleep(4000);
	}
	return 0;
}

int hs_await(){
	int w=prmm[0].i*1000;
	timeval time1,time2;
	gettimeofday( &time1,  NULL );
	while(1){
		KEventChk();
		gettimeofday( &time2,  NULL );
		if((time2.tv_sec-time1.tv_sec)*1000000
			+time2.tv_usec-time1.tv_usec  >= w){
			break;
		}
		usleep(2000);
	}
	return 0;
}


int hs_stop(){
	while(1){
		usleep(4000);
		KEventChk();
		if(eventflag){
			break;
		}
	}
	return 0;
}


int nchars = 0;
unsigned char pbbuf[10];
extern int errno;
int kbhit(){
	unsigned char c;
	int n;
	struct termios old, newt;
	if(nchars > 0){
		// ɤᤵ줿Ϥ
		return 1;
	}
	//꡼ɡޡꤹ
	tcgetattr(0, &old);
	newt = old;
	newt.c_lflag &= ~ICANON;
	newt.c_cc[VMIN] = 0;
	newt.c_cc[VTIME] = 0; // 0
	tcsetattr(0, TCSADRAIN, &newt);
	// Ϥɤ
	while ((n = read(0, &c, 1)) < 0 && errno == EINTR)
	;
	// ꡼ɡޡ
	tcsetattr(0, TCSADRAIN, &old);
	if (n == 1) {
		// Ϥɤ᤹
		pbbuf[nchars++]=c;
		return 1;
	}
	return 0;
}

int getch(){
	unsigned char c;
	int n;
	if (nchars > 0)
		return pbbuf[--nchars];
	while ((n = read(0, &c, 1)) < 0 && errno == EINTR)
	;
	if (n == 0)
		return -1;
	return (int)c;
}

int hs_getkey(){
	if(prmm[1].i<=3){
		prmm[0].pInt[0]=sval.mbutton[prmm[1].i];
		return 0;
	}
	prmm[0].pInt[0]=(kbhit() ?getch():0 );
	return 0;
}

int hs_font(){
	bms1->hWnd->fs=prmm[1].i;
	if(prmm[2].i==0){
		font1 = XLoadQueryFont(display, prmm[0].s);
	}else{
		font2 = XLoadQueryFont(display, prmm[0].s);
	}
	return 0;
}

int hs_mes(){
	//const int fs=bms1->hWnd->fs;
	if(prmm[0].type!=2){
		sprintf(prmm[0].s,"%d",prmm[0].i);
	}
	TextOut(bms1->hDC,bms1->curx,bms1->cury,prmm[0].s,0);

	if(prmm[1].type!=1){
		bms1->cury+=fs;
	}
	MoveTo(bms1->hDC,bms1->curx,bms1->cury);
	return 0;
}

int hs_pos(){
	bms1->curx=prmm[0].i;
	if(prms>1)bms1->cury=prmm[1].i;
	MoveTo(bms1->hDC,bms1->curx,bms1->cury);
	return 0;
}

int hs_color(){
	int c=(prmm[0].i<<16) + (prmm[1].i<<8) + prmm[2].i;
	SetTextColor(bms1->hDC,c);
	return 0;
}

int hs_pset(){
	if(prms>0){
		bms1->curx=prmm[0].i;
		bms1->cury=prmm[1].i;
	}
	DrawPoint(bms1->hDC, bms1->curx, bms1->cury);
	return 0;
}

int hs_pget(){
	//XShmCreateImageȤ٤...
	if(prmm[0].i<0 || prmm[0].i>=bms1->sx ||
	   prmm[1].i<0 || prmm[1].i>=bms1->sy)
			return 0;
	XImage *img;
	img = XGetImage(display, bms1->pix, prmm[0].i,prmm[1].i, 1,1,
				0xffffff ,ZPixmap);
	sval.bval=((unsigned char*)img->data)[0];
	sval.gval=((unsigned char*)img->data)[1];
	sval.rval=((unsigned char*)img->data)[2];
	XDestroyImage(img);
	return 0;
}

int hs_line(){
	if(prms>2){
		MoveTo(bms1->hDC,prmm[2].i,prmm[3].i);
	}
	LineTo(bms1->hDC, prmm[0].i, prmm[1].i);
	bms1->curx=prmm[0].i;
	bms1->cury=prmm[1].i;
	return 0;
}

int hs_boxf(){
	Rectangle(bms1->hDC,prmm[0].i, prmm[1].i, prmm[2].i, prmm[3].i);
	return 0;
}

int hs_cls(){
	SetTextColor(bms1->hDC,0xffffff);
	Rectangle(bms1->hDC,0,0,bms1->sx,bms1->sy);
	SetTextColor(bms1->hDC,0x0);
	MoveTo(bms1->hDC,0,0);

	int id;
	for(id=0;id<bms1->objs;id++){
		DeleteWindow(bms1->obj[id]);
	}
	bms1->objs=0;
	bms1->curx=0;
	bms1->cury=0;
	return 0;
}

int hs_objsize(){
	bms1->objw=prmm[0].i;
	if(prms>1)bms1->objh=prmm[1].i;
	return 0;
}

int hs_title(){
	SetWindowText(bms1->hWnd,prmm[0].s);
	return 0;
}


int hs_button(){
	bms1->objd[bms1->objs]=hsinfo.label[prmm[1].i];
	bms1->obj[bms1->objs]=CreateWindow("obj",prmm[0].s,10,
				bms1->curx,bms1->cury,bms1->objw,bms1->objh,bms1->hWnd);
	// X
	XSelectInput(display, bms1->obj[bms1->objs]->wnd,
			ButtonPressMask | ButtonReleaseMask | ExposureMask);

	ShowWindow(bms1->obj[bms1->objs],1);
	bms1->objs++;
	bms1->cury+=bms1->objh;
	MoveTo(bms1->hDC,bms1->curx,bms1->cury);
	return 0;
}

int hs_chkbox(){
	bms1->objd[bms1->objs]=prmm[0].i;
	bms1->obj[bms1->objs]=CreateWindow("obj",prmm[1].s,11,
				bms1->curx,bms1->cury,bms1->objw,bms1->objh,bms1->hWnd);
	// X
	XSelectInput(display, bms1->obj[bms1->objs]->wnd,
			ButtonPressMask | ButtonReleaseMask | ExposureMask);

	ShowWindow(bms1->obj[bms1->objs],1);
	bms1->objs++;
	bms1->cury+=bms1->objh;
	MoveTo(bms1->hDC,bms1->curx,bms1->cury);
	return 0;
}

int hs_input(){
	bms1->objd[bms1->objs]=prmm[0].i;
	bms1->obj[bms1->objs]=CreateWindow("obj",prmm[0].pStr,12,
				bms1->curx,bms1->cury,bms1->objw,bms1->objh,bms1->hWnd);
	// X
	XSelectInput(display, bms1->obj[bms1->objs]->wnd,
			ButtonPressMask | ButtonReleaseMask |
			ExposureMask | KeyPressMask);

	ShowWindow(bms1->obj[bms1->objs],1);
	bms1->objs++;
	bms1->cury+=bms1->objh;
	MoveTo(bms1->hDC,bms1->curx,bms1->cury);
	return 0;
}

int hs_screen(){
	if(bmscr[prmm[0].i]){
		HSP_FreeBMS(bmscr[prmm[0].i]);
		free(bmscr[prmm[0].i]);
	}
	bmscr[prmm[0].i]=(BMSCR*)malloc(sizeof(BMSCR));
	HSP_InitBMS(bmscr[prmm[0].i],prmm[1].i,prmm[2].i);
	bms1=bmscr[prmm[0].i];
	ShowWindow(bms1->hWnd,1);
	XSelectInput(display,bms1->hWnd->wnd,ExposureMask | PointerMotionMask
		| ButtonPressMask | ButtonReleaseMask | KeyPressMask );
	//printf("ok--\n");
	return 0;
}

int hs_gsel(){
	if(bmscr[prmm[0].i]){
		bms1=bmscr[prmm[0].i];
	}
	if(prms>1){
		if(prmm[1].i<0)
			ShowWindow(bms1->hWnd,0);
		if(prmm[1].i==1)
			ShowWindow(bms1->hWnd,1);
		if(prmm[1].i==2)
			ShowWindow(bms1->hWnd,1);
	}
	return 0;
}


////////////////////////////////////////////////////////////////////
//
//

int excmd_init(int argc, char *argv[], char *envp[]){


	// for x window
	g_argv=argv;
	g_argc=argc;
	display = XOpenDisplay(NULL);

	bmscr[0]=(BMSCR*)malloc(sizeof(BMSCR));
	HSP_InitBMS(bmscr[0],640,480);
	bms1=bmscr[0];

	font1 = XLoadQueryFont(display, "a14" );
	font2 = XLoadQueryFont(display, "k14" );
	fs=14;
	//font1 = XLoadQueryFont(display, "fixed" );
	//font2 = XLoadQueryFont(display,
	//		 "-jis-fixed-medium-r-normal--16-*-*-*-c-*-jisx0208.1983-0" );
	ShowWindow(bms1->hWnd,1);
	XSelectInput(display,bms1->hWnd->wnd,ExposureMask | PointerMotionMask
		| ButtonPressMask | ButtonReleaseMask | KeyPressMask );

	return 0;
}
int excmd_end(){
	int i;
	for(i=0;i<32;i++){
		if(bmscr[i]){
			HSP_FreeBMS(bmscr[i]);
			free(bmscr[i]);
			bmscr[i]=NULL;
		}
	}
	XCloseDisplay(display);

	return 0;
}

void gui_getWinsize(int *x ,int *y)
{
	*x=bms1->sx;
	*y=bms1->sy;
}

void gui_getCurrentPos(int *x,int *y)
{
        *x=bms1->curx;
        *y=bms1->cury;
}

void gui_getPointer(int *x ,int *y)
{
	*x=sval.mousex;
	*y=sval.mousey;
}

int excmd_list(FUNCINFO* hs_func,int size)
{
	hs_func[0x10].func=hs_wait;
	hs_func[0x10].ptyp=0x00001;
	hs_func[0x13].func=hs_mes;
	hs_func[0x13].ptyp=0x00000;

	hs_func[0x1a].func=hs_stop;
	hs_func[0x1a].ptyp=0x00000;

	hs_func[0x21].func=hs_await;
	hs_func[0x21].ptyp=0x00001;
	//0x48xx
	hs_func[0x00|0x80].func=hs_button;
	hs_func[0x00|0x80].ptyp=0x00012;
	hs_func[0x10|0x80].func=hs_title;
	hs_func[0x10|0x80].ptyp=0x00012;
	hs_func[0x11|0x80].func=hs_pos;
	hs_func[0x11|0x80].ptyp=0x00011;
	hs_func[0x13|0x80].func=hs_cls;
	hs_func[0x13|0x80].ptyp=0x00011;
	hs_func[0x14|0x80].func=hs_font;
	hs_func[0x14|0x80].ptyp=0x00012;
	hs_func[0x16|0x80].func=hs_objsize;
	hs_func[0x16|0x80].ptyp=0x00011;
	//hs_func[0x17|0x80].func=hs_picload;
	//hs_func[0x17|0x80].ptyp=0x00012;
	hs_func[0x18|0x80].func=hs_color;
	hs_func[0x18|0x80].ptyp=0x00111;
	hs_func[0x1d|0x80].func=hs_gsel;
	hs_func[0x1d|0x80].ptyp=0x00111;
	hs_func[0x23|0x80].func=hs_getkey;
	hs_func[0x23|0x80].ptyp=0x00119;
	hs_func[0x27|0x80].func=hs_input;
	hs_func[0x27|0x80].ptyp=0x01118;
	//hs_func[0x28|0x80].func=hs_mesbox;
	//hs_func[0x28|0x80].ptyp=0x01118;
	hs_func[0x2a|0x80].func=hs_screen;
	hs_func[0x2a|0x80].ptyp=0x01111;
	//hs_func[0x2c|0x80].func=hs_dialog;
	//hs_func[0x2c|0x80].ptyp=0x00212;

	hs_func[0x31|0x80].func=hs_boxf;
	hs_func[0x31|0x80].ptyp=0x01111;
	hs_func[0x32|0x80].func=hs_pget;
	hs_func[0x32|0x80].ptyp=0x00011;
	hs_func[0x33|0x80].func=hs_pset;
	hs_func[0x33|0x80].ptyp=0x00011;

	//hs_func[0x39|0x80].func=hs_clrobj;
	//hs_func[0x39|0x80].ptyp=0x00011;
	hs_func[0x3a|0x80].func=hs_chkbox;
	hs_func[0x3a|0x80].ptyp=0x00032;
	hs_func[0x3b|0x80].func=hs_line;
	hs_func[0x3b|0x80].ptyp=0x01111;
	//hs_func[0x3c|0x80].func=hs_stick;
	//hs_func[0x3c|0x80].ptyp=0x00119;
	//hs_func[0x3e|0x80].func=hs_combox;
	//hs_func[0x3e|0x80].ptyp=0x01128;

	//hs_func[0x40|0x80].func=hs_objprm;
	//hs_func[0x40|0x80].ptyp=0x00001;
	//hs_func[0x4b|0x80].func=hs_listbox;
	//hs_func[0x4b|0x80].ptyp=0x01129;
	return 0;
}

////////////////////////////////////////////////////////////////////////

