// xhsp.cpp
//		HSP 󥿥ץ꥿
//

#define START_AX "start.ax"
#define HSPVER 0x0500
#define HSPSTAT 4
//#define HSPDBG // ǥХå

#include <stdio.h>
#include <time.h>
#include "xhsp.h"

// OS¸
#ifdef WIN32
#include <windows.h>
#include <direct.h>
#else
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/time.h>
#endif

struct DPMINFO{
	FILE* hPF;
	long flag;
	long offset;
	char file[1024];
}dpm;

struct AXHEAD{
	char sig[4];
	long version;
	long valcnt;
	unsigned long file_size;
	unsigned long code_start;
	unsigned long code_size;
	unsigned long str_start;
	unsigned long str_size;
	unsigned long label_start;
	unsigned long label_size;
	unsigned long debug_start;
	unsigned long debug_size;
	unsigned long dlllst_start;
	unsigned long dlllst_size;
	unsigned long dllc_start;
	unsigned long dllc_size;
	unsigned long mod_start;
	unsigned long mod_size;
	//unsigned long D[2];
};

bool ax_load(HSP_INFO &ax,char *lpFile);
void ax_free(const HSP_INFO &ax);
int hsp_run(long pt);
int getprm(int prmtyp, const unsigned short *code,const HSP_INFO *ax);

int excmd_init(int argc, char *argv[], char *envp[]);
int excmd_end();
int excmd_list(FUNCINFO* flist,int size);

void gui_getPointer(int *x,int *y);
void gui_getWinsize(int *x,int *y);
void gui_getCurrentPos(int *x,int *y);

PARAM prmm[12];
PARAM modprm[8];
int prms;
HSP_INFO hsinfo;
SYSTEMVAL sval;

char *exefile;

//////////////////////////////////////////////////////////////////
//	main
//

int main(int argc, char *argv[], char *envp[]){
	int i=1;
#ifdef HSPDBG
	char asfile[512];
	if(argc>2) strcpy(asfile,argv[1]);
	i=2;
#endif
	sval.cmdline[0]='\0';
	for(;i<argc;i++){
		if(i>1)strcat(sval.cmdline," ");
		strcat(sval.cmdline,argv[i]);
	}
	exefile=argv[0];
	getcwd(sval.curdir,512);
	static char*s="HSPHED~~\0_1_________2_________3______";
	hsinfo.fskiperr=0;
	if(!s[0]){
		int o=atoi(s+9)+65536;
		dpm_set(exefile,o);
	}
#ifdef HSPDBG
	if(!ax_load(hsinfo,asfile) && !ax_load(hsinfo,START_AX)){
#else
	if(!ax_load(hsinfo,START_AX)){
#endif
		fprintf(stderr,START_AX " not found\n");
		return 0;
	}

	excmd_init(argc, argv, envp);

	int r=hsp_run(0);

	excmd_end();

	ax_free(hsinfo);
	if(dpm.flag)
		fclose(dpm.hPF);
	return r;
}

////////////////////////////////////////////////////////////////////////
//		HSPɸؿ

int hs_dim(){
	if(prmm[0].type!=3)
		return 6; // Type Error!
	int size=sizeof(int);
	int i=0;
	while(prmm[i+1].i && i<4){
		hsinfo.vallist[prmm[0].i].dsize[i]=prmm[i+1].i;
		size*=prmm[i+1].i;
		i++;
	}
	if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
	hsinfo.vallist[prmm[0].i].mode=2;
	hsinfo.vallist[prmm[0].i].type=0;
	hsinfo.vallist[prmm[0].i].size=size;
	hsinfo.vallist[prmm[0].i].pStr=(unsigned char*)malloc(size);
	memset(hsinfo.vallist[prmm[0].i].pStr,0,size);
	return 0;
}

int hs_sdim(){
	if(prmm[0].type!=3)
		return 6; // Type Error!
	int size=sizeof(char);
	int i=0;
	while(prmm[i+1].i && i<4){
		hsinfo.vallist[prmm[0].i].dsize[i]=prmm[i+1].i;
		size*=prmm[i+1].i;
		i++;
	}
	if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
	hsinfo.vallist[prmm[0].i].mode=2;
	hsinfo.vallist[prmm[0].i].type=1;
	hsinfo.vallist[prmm[0].i].size=size;
	hsinfo.vallist[prmm[0].i].pStr=(unsigned char*)malloc(size);
	memset(hsinfo.vallist[prmm[0].i].pStr,0,size);
	return 0;
}

int hs_alloc(){
	if(prmm[0].type!=3)
		return 6; // Type Error!
	if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
	hsinfo.vallist[prmm[0].i].mode=2;
	hsinfo.vallist[prmm[0].i].type=0;
	hsinfo.vallist[prmm[0].i].size=prmm[1].i;
	hsinfo.vallist[prmm[0].i].pStr=(unsigned char*)malloc(prmm[1].i);
	memset(hsinfo.vallist[prmm[0].i].pStr,0,prmm[1].i);
	return 0;
}

int hs_dup(){
	if(prmm[0].type!=3)
		return 6; // Type Error!
	if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
	hsinfo.vallist[prmm[0].i].mode=1;
	hsinfo.vallist[prmm[0].i].type=(prmm[1].type>>4)&1;
	hsinfo.vallist[prmm[0].i].size=1024;
	hsinfo.vallist[prmm[0].i].pStr=(unsigned char*)prmm[1].pStr;
	return 0;
}

int hs_mref(){
	if(prmm[0].type!=3)
		return 6; // Type Error!
	if(prmm[1].i&1024){
		prmm[2].i=modprm[prmm[1].i^1024].i;
		prmm[1].i=-1;
	}
	if(prmm[1].i<0){
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=0;
		hsinfo.vallist[prmm[0].i].size=sizeof(PVAL);
		hsinfo.vallist[prmm[0].i].pInt=(int*)&hsinfo.vallist[prmm[2].i];
		return 0;
	}
	if(prmm[1].i<8){
		hsinfo.vallist[prmm[0].i].type=0;
		hsinfo.vallist[prmm[0].i].pInt[0]=modprm[prmm[1].i].i;
		return 0;
	}
	if(prmm[1].i<24){
		prmm[1].i-=16;
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=0;
		hsinfo.vallist[prmm[0].i].size=256;
		hsinfo.vallist[prmm[0].i].pInt=hsinfo.vallist[modprm[prmm[1].i].i].pInt+modprm[prmm[1].i].p;
		return 0;
	}
	if(prmm[1].i<32){
		prmm[1].i-=24;
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=1;
		hsinfo.vallist[prmm[0].i].size=256;
		hsinfo.vallist[prmm[0].i].pStr=hsinfo.vallist[modprm[prmm[1].i].i].pStr+modprm[prmm[1].i].p;
		return 0;
	}
	if(prmm[1].i<48){
		prmm[1].i-=32;
		hsinfo.vallist[prmm[0].i].type=1;
		strcpy((char*)hsinfo.vallist[prmm[0].i].pStr,modprm[prmm[1].i].s);
		return 0;
	}
	if(prmm[1].i<56){
		prmm[1].i-=48;
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=0;
		hsinfo.vallist[prmm[0].i].size=256;
		hsinfo.vallist[prmm[0].i].pInt=modprm[prmm[1].i].pInt;
		return 0;
	}
	if(prmm[1].i<64){
		prmm[1].i-=56;
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=1;
		hsinfo.vallist[prmm[0].i].size=256;
		hsinfo.vallist[prmm[0].i].pStr=(unsigned char*)modprm[prmm[1].i].pStr;
		return 0;
	}
	if(prmm[1].i==64){
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=1;
		hsinfo.vallist[prmm[0].i].size=4;
		hsinfo.vallist[prmm[0].i].pInt=&sval.stat;
		return 0;
	}
	if(prmm[1].i==65){
		if(hsinfo.vallist[prmm[0].i].mode==2)free(hsinfo.vallist[prmm[0].i].pStr);
		hsinfo.vallist[prmm[0].i].mode=1;
		hsinfo.vallist[prmm[0].i].type=1;
		hsinfo.vallist[prmm[0].i].size=4;
		hsinfo.vallist[prmm[0].i].pStr=(unsigned char*)sval.refstr;
		return 0;
	}
	return 0;
}

int hs_poke(){
	if((prmm[0].type&0xf)==4){//buf
		if(prmm[2].type==0x01){//char
			prmm[0].pStr[prmm[1].i]=prmm[2].i;
		}
		if(prmm[2].type==0x02){//str
			strcpy(prmm[0].pStr+prmm[1].i,prmm[2].s);
		}
	}else{
		return 6; // Type Error!
	}
	return 0;
}

int hs_peek(){
	if(prmm[0].type==0x04){//Val char
		prmm[0].pInt[0]=(unsigned char)prmm[1].pStr[prmm[2].i];
	}else if(prmm[0].type==0x14){//Val str
		strcpy(prmm[0].pStr,prmm[1].pStr+prmm[2].i);
	}else{
		return 6; // Type Error!
	}
	return 0;
}

int hs_wpoke(){
	if((prmm[0].type&0xf)==4){//Val
		*(unsigned short*)(prmm[0].pStr+prmm[1].i)=prmm[2].i;
	}else{
		return 6; // Type Error!
	}
	return 0;
}

int hs_wpeek(){
	if((prmm[0].type&0xf)==4){//Val
		prmm[0].pInt[0]=*(unsigned short*)(prmm[1].pStr+prmm[2].i);
	}else{
		return 6; // Type Error!
	}
	return 0;
}

int hs_skiperr(){
	hsinfo.fskiperr=prmm[0].i;
	return 0;
}

int hs_run(){
	if(dpm_exist(prmm[0].s)<=0){
		return 12;
	}
	ax_free(hsinfo);
	ax_load(hsinfo,prmm[0].s);
	hsinfo.pt=0;
	return 0;
}

int hs_rnd(){
	if(prmm[0].type==3){//Val
		hsinfo.vallist[prmm[0].i].type=0;
		hsinfo.vallist[prmm[0].i].pInt[prmm[0].p]=rand()%prmm[1].i;
	}else{
		return 6; // Type Error!
	}
	return 0;
}

int hs_int(){
	if(prmm[0].type==3 && hsinfo.vallist[prmm[0].i].type){//Val
		long i;
		hsinfo.vallist[prmm[0].i].type=0;
		if(hsinfo.vallist[prmm[0].i].pStr[0]!='$'){
			i=atoi((char*)hsinfo.vallist[prmm[0].i].pStr);
		}else{
			i=strtol((char*)hsinfo.vallist[prmm[0].i].pStr+1,NULL,16);
		}
		hsinfo.vallist[prmm[0].i].pInt[0]=i;
	}
	return 0;
}

int hs_str(){
	if(prmm[0].type==3){//Val
		char s[10];
		if(prmm[1].i<16){
			sprintf(s,"%%0%dd",prmm[1].i);
		}else{
			sprintf(s,"%%0%dx",prmm[1].i-16);
		}
		hsinfo.vallist[prmm[0].i].type=1;
		sprintf((char*)hsinfo.vallist[prmm[0].i].pStr,s,hsinfo.vallist[prmm[0].i].pInt[0]);
	}
	return 0;
}


int hs_strlen(){
	if(prmm[0].type==4){
		prmm[0].pInt[0]=strlen(prmm[1].pStr);
	}
	return 0;
}

int hs_getstr(){
	if(prmm[0].type==0x14){
		int f=0;
		int i=0;
		while(prmm[1].pStr[i+prmm[2].i]!=prmm[3].i){
			if(!prmm[1].pStr[i+prmm[2].i] || prmm[1].pStr[i+prmm[2].i]==13){
				f=1;
				break;
			}
			prmm[0].pStr[i]=prmm[1].pStr[i+prmm[2].i];
			i++;
		}
		prmm[0].pStr[i]=0;
		sval.stat=prmm[1].pStr[i+prmm[2].i];
		sval.strsize=i+1+f;
	}
	return 0;
}

int hs_strmid(){
	if(prmm[0].type==0x14){
		int i=0;
		for(i=0;prmm[1].pStr[i+prmm[2].i]&&i<prmm[3].i;i++){
			prmm[0].pStr[i]=prmm[1].pStr[i+prmm[2].i];
		}
		prmm[0].pStr[i]=0;
	}
	return 0;
}

int hs_instr(){
	if(prmm[0].type==0x4){
		int l=strlen(prmm[2].s);
		int i=0;
		for(i=0;prmm[1].pStr[i+prmm[3].i];i++){
			if(memcmp(prmm[1].pStr+i+prmm[3].i,prmm[2].s,l)==0){
				prmm[0].pInt[0]=i;
				return 0;
			}
		}
		prmm[0].pInt[0]=-1;
	}
	return 0;
}

int hs_memcpy(){
	if((prmm[0].type&0xf)==4){
		memcpy(prmm[0].pStr+prmm[3].i,prmm[1].pStr+prmm[4].i,prmm[2].i);
	}
	return 0;
}

int hs_memset(){
	if((prmm[0].type&0xf)==4){
		memset(prmm[0].pStr+prmm[3].i,prmm[1].i,prmm[2].i);
	}
	return 0;
}

////////////////////   file
int hs_bload(){
	if(prms<4)
		prmm[3].i=0;
	if((prmm[1].type&0xf)!=4)//Pointer to buf
		return 6;
	if(!dpm_load(prmm[1].pStr,prmm[2].i,prmm[0].s,prmm[3].i)){
		return 12;
	}
	return 0;
}

int hs_bsave(){
	if((prmm[1].type&0xf)==4){//Pointer to buf
		if(prms<4)
			bsave(prmm[1].pStr,prmm[2].i,prmm[0].s);
		else
			bsave2(prmm[1].pStr,prmm[2].i,prmm[0].s,prmm[3].i);
	}
	return 0;
}
int hs_bcopy(){
	if(prmm[0].type!=2 || prmm[1].type!=2)
		return 6;
	long fsize;
	FILE *fp=hsp_fopen(prmm[0].s,&fsize);
	if(fp == NULL)
		return 12;
	FILE *fp2=fopen(prmm[1].s,"wb");
	if(fp2 == NULL)
		return 12;
	char buf[1024];
	int s,sz=0;
	while(1){
		if(fsize-sz<1024){
			s=fread(buf,1,fsize-sz,fp);
		}else{
			s=fread(buf,1,1024,fp);
		}
		sz+=s;
		fwrite(buf,1,s,fp2);
		if(s==0 || sz>=fsize)break;
	}

	fclose(fp2);
	hsp_fclose(fp);
	return 0;
}

int hs_exist(){
	if(prmm[0].type==2){
		sval.strsize=dpm_exist(prmm[0].s);
	}
	return 0;
}

///////////////  note
PVAL* noteval;
char *notebuf;
int hs_notesel(){
	if(prmm[0].type==0x3){
		noteval=&hsinfo.vallist[prmm[0].i];
		notebuf=(char*)noteval->pStr;
	}else{
		return 6;
	}
	//if(prmm[0].type==0x14){
	//	notebuf=prmm[0].pStr;
	//}
	return 0;
}

int hs_notemax(){
	int i=0,m=0;
	while(notebuf[i]){
		if(notebuf[i]==10){
			if(notebuf[i+1]!=0)m++;
		}
		if(notebuf[i]==13){
			if(notebuf[i+1]==10)i++;
			if(notebuf[i+1]!=0)m++;
		}
		i++;
	}
	m++;
	if(prmm[0].type==4){
		prmm[0].pInt[0]=m;
	}
	return 0;
}

int hs_noteadd(){
	int i=0,m=0;
	if(prmm[0].type!=2)return 0;
	if(prmm[1].i<0){
		int l=strlen(notebuf);
		if(notebuf[l-1]!=10 && notebuf[l-1]!=13){
			strcpy(notebuf+l,"\n");
			l+=strlen("\n");
		}
		strcpy(notebuf+l,strcat(prmm[0].s,"\n"));
		return 0;
	}
	while(m<prmm[1].i && notebuf[i]){
		if(notebuf[i]==10 || notebuf[i]==13){
			i += notebuf[i]==13 && notebuf[i+1]==10;
			m++;
			if(notebuf[i+1]==10)i++;
		}else{
			if(notebuf[i+1]==0){
				m++;
				notebuf[i+1]=13;
				notebuf[i+2]=10;
				notebuf[i+3]=0;
				i+=2;
			}
		}
		i++;
	}
	if(m==prmm[1].i){
		int l=strlen(prmm[0].s);
		int l2;
		if(prmm[2].i){
			l2=strcspn(notebuf+i,"\n\r");
			if(notebuf[i+l2]==10 || notebuf[i+l2]==13){
				l2 += notebuf[i+l2]==13 && notebuf[i+l2+1]==10;
				l2++;
			}
			if(l<=l2){
				memcpy(notebuf+i,prmm[0].s,l);
				notebuf[i+l]=13;
				notebuf[i+l+1]=10;
				strcpy(notebuf+i+l+2,notebuf+i+l2);
			}else{
				memcpy(notebuf+i+l+2,notebuf+i+l2,strlen(notebuf+i+l2)+1);
				memcpy(notebuf+i,prmm[0].s,l);
				notebuf[i+l]=13;
				notebuf[i+l+1]=10;
			}
		}else{
			l2=i+strlen(notebuf+i);
			while((l2+1)>i){
				notebuf[l2+l+2]=notebuf[l2];
				l2--;
			}
			memcpy(notebuf+i,prmm[0].s,l);
			notebuf[i+l  ]=13;
			notebuf[i+l+1]=10;
		}
	}
	return 0;
}

int hs_noteget(){
	int i=0,m=0;
	while(m<prmm[1].i && notebuf[i]){
		if(notebuf[i]==10 || notebuf[i]==13){
			i += notebuf[i]==13 && notebuf[i+1]==10;
			m++;
		}
		i++;
	}
	if(prmm[0].type==0x14 ){
		if(m==prmm[1].i){
			int l2=strcspn(notebuf+i,"\n\r");
			memcpy(prmm[0].pStr,notebuf+i,l2);
			prmm[0].pStr[l2]=0;
		}else
			prmm[0].pStr[0]=0;
	}
	return 0;
}


int hs_notedel(){
	int i=0,m=0;
	while(m<prmm[0].i && notebuf[i]){
		if(notebuf[i]==10 || notebuf[i]==13){
			i += notebuf[i]==13 && notebuf[i+1]==10;
			m++;
		}else{
			if(notebuf[i+1]==0){
				m++;
				notebuf[i+1]=13;
				notebuf[i+2]=10;
				notebuf[i+3]=0;
				i+=2;
			}
		}
		i++;
	}
	if(m==prmm[0].i){
		int l2=strcspn(notebuf+i,"\n\r");
		if(notebuf[i+l2]==13){
			l2++;
			if(notebuf[i+l2]==10)l2++;
		}
		strcpy(notebuf+i,notebuf+i+l2);
	}
	return 0;
}
int hs_noteload(){
	int size=dpm_exist(prmm[0].s);
	if(size<0) return 12; // FILE not found
	free(noteval->pStr);
	noteval->pStr=(unsigned char*)malloc(size+64);
	notebuf=(char*)noteval->pStr;
	dpm_load(notebuf,size,prmm[0].s,0);
	notebuf[size]=0;
	return 0;
}

int hs_notesave(){
	bsave(notebuf,strlen(notebuf),prmm[0].s);
	return 0;
}

///////////////  other



int hs_randomize(){
	 srand(clock());
	return 0;
}

int hs_gettime(){
	tm t;
	time_t tt;
	time(&tt);
	//localtime_r(&tt,&t);
	memcpy(&t,localtime(&tt),sizeof(t));
	if(prmm[1].i==0)
		prmm[0].pInt[0]=t.tm_year+1900;
	else if(prmm[1].i==1)
		prmm[0].pInt[0]=t.tm_mon;
	else if(prmm[1].i==2)
		prmm[0].pInt[0]=t.tm_wday;
	else if(prmm[1].i==3)
		prmm[0].pInt[0]=t.tm_mday;
	else if(prmm[1].i==4)
		prmm[0].pInt[0]=t.tm_hour;
	else if(prmm[1].i==5)
		prmm[0].pInt[0]=t.tm_min;
	else if(prmm[1].i==6)
		prmm[0].pInt[0]=t.tm_sec;
	else if(prmm[1].i==7){
#ifdef WIN32
		SYSTEMTIME t;
		GetLocalTime(&t);
		prmm[0].pInt[0]=t.wMilliseconds;
#else
		timeval t;
		gettimeofday(&t,NULL);
		prmm[0].pInt[0]=t.tv_usec/1000%1000;
#endif
	}
	return 0;
}


int hs_exec(){
	//hsinfo.pt+=getprm(0x00012,hsinfo.code+hsinfo.pt,&ax);
	system(prmm[0].s);
	return 0;
}

int hs_chdir(){
	//hsinfo.pt+=getprm(0x00002,hsinfo.code+hsinfo.pt,&ax);
	if(prmm[0].type==2){
		chdir(prmm[0].s);
		getcwd(sval.curdir,512);
	}else{
		return 6;
	}
	return 0;
}

int hs_mkdir(){
	if(prmm[0].type==2){
#ifdef WIN32
		mkdir(prmm[0].s);
#else
		mkdir(prmm[0].s,S_IRWXU | S_IRWXG | S_IRWXO);
#endif
	}
	return 0;
}
int hs_delete(){
	if(prmm[0].type!=2){
		return 0;
	}
	if(unlink(prmm[0].s))
		return 12;
	return 0;
}

int hs_sysinfo(){
	if(prmm[0].type!=3)
		return 6; // Type Error!

	switch(prmm[1].i){
	case 0:
		hsinfo.vallist[prmm[0].i].type=1;
		strcpy((char *)hsinfo.vallist[prmm[0].i].pStr,"Unknown");
		break;
	case 1:
#ifndef WIN32
		hsinfo.vallist[prmm[0].i].type=1;
		sprintf((char *)hsinfo.vallist[prmm[0].i].pStr,"%d",getuid());
#endif
		break;
	}
	return 0;
}


// 磻ɥ
int WCChk(char *w, char *s)
{
	while(*w && *s){
		if(*w=='*'){
			w++;
			while(WCChk(w,++s)==0)
				if(!*s) break;
		}else if(*w!='?' && *w!=*s){
			return 0;
		}else{
			w++;
			s++;
		}
	}
	return *w==*s;
}


int hs_dirlist(){
	if(prmm[0].type!=0x14)
		return 6;
	if(prmm[2].type!=1){
		prmm[2].i=0;
	}
#ifdef WIN32
	// not supported
#else
	char wc[256];
	dirent *dir;
	DIR *dp;
	int i=0,p=-1;
	if(prmm[1].type==2){
		while(prmm[1].s[i]){
			if(prmm[1].s[i]=='/')p=i;
			i++;
		}
	}
	if(p>=0){
		strcpy(wc,prmm[1].s+p+1);
		prmm[1].s[p+1]='\0';
		dp=opendir(prmm[1].s);
	}else{
		if(i) strcpy(wc,prmm[1].s);
		dp=opendir(sval.curdir);
	}
	sval.stat=0;
	if(dp==NULL)
		return 0;

	p=0;
	while ((dir = readdir(dp)) != NULL){
                if (dir->d_ino == 0)
                        continue;
		if(prmm[1].type==2 && WCChk(wc,dir->d_name)==0) continue;
		switch(prmm[2].i){
		case 1:
			if(dir->d_type & DT_DIR)
				continue;
			break;
		case 2:
			if(dir->d_name[0]=='.')
				continue;
			break;
		case 3:
			if(dir->d_name[0]=='.' || (dir->d_type & DT_DIR))
				continue;
			break;
		case 5:
			if((dir->d_type & DT_DIR)==0)
				continue;
			break;
		case 6:
			if(dir->d_name[0]!='.')
				continue;
			break;
		case 7:
			if(dir->d_name[0]!='.' && (dir->d_type & DT_DIR)==0)
				continue;
			break;
		}
		strcpy(prmm[0].pStr+p,dir->d_name);
		p+=strlen(dir->d_name);
		strcpy(prmm[0].pStr+p,"\n");
		p+=strlen("\n");
		printf("%s\t%d\n", dir->d_name, dir->d_ino);
		sval.stat++;
	}
	prmm[0].pStr[p]=0;
	closedir(dp);
#endif
	return 0;
}




////////////////////////////////////////////////////////////////////////
#ifdef HSPDBG
int getlineno(int pt,char *file)
{
	AXHEAD* head=(AXHEAD*)hsinfo.buf;
	unsigned char *dbg=hsinfo.buf+head->debug_start;
	file[0]='\0';
	int p=0;
	int l=-1;
	while(p<head->debug_size){
		if(dbg[p]<0xFD){
			pt-=dbg[p];
			if(pt<=0)
				break;
			l++;
		}
		if(dbg[p]==0xFD) //val
			return -1;
		if(dbg[p]==0xFE){
			strcpy(file,(char*)hsinfo.str+dbg[p+1]+(dbg[p+2]<<8));
			l=dbg[p+3]+(dbg[p+4]<<8)+(dbg[p+5]<<16);
			p+=5;
		}
		if(dbg[p]==0xFF)
			return -1;
		p++;
	}
	return l;
}
#endif

int hsp_run(long p){
	FUNCINFO hs_func[256];
	memset(hs_func,0,sizeof(hs_func));
	excmd_list(hs_func,256);
	// 0:any 1:int 2:str 3:val  8:buf 9:intbuf A:strbuf
	//0x40xx
	hs_func[0x14].func=hs_dim;
	hs_func[0x14].ptyp=0x11113;
	hs_func[0x15].func=hs_sdim;
	hs_func[0x15].ptyp=0x11113;
	hs_func[0x16].func=hs_alloc;
	hs_func[0x16].ptyp=0x00013;
	hs_func[0x17].func=hs_bload;
	hs_func[0x17].ptyp=0x00182;
	hs_func[0x18].func=hs_bsave;
	hs_func[0x18].ptyp=0x00182;
	hs_func[0x19].func=hs_bcopy;
	hs_func[0x19].ptyp=0x00022;
	//hs_func[0x1a].func=hs_stop;
	//hs_func[0x1a].ptyp=0x00000;
	hs_func[0x1b].func=hs_run;
	hs_func[0x1b].ptyp=0x00012;
	hs_func[0x1c].func=hs_rnd;
	hs_func[0x1c].ptyp=0x00013;
	hs_func[0x1d].func=hs_str;
	hs_func[0x1d].ptyp=0x00013;
	hs_func[0x1e].func=hs_int;
	hs_func[0x1e].ptyp=0x00003;
	hs_func[0x1f].func=hs_skiperr;
	hs_func[0x1f].ptyp=0x00001;
	hs_func[0x20].func=hs_dup;
	hs_func[0x20].ptyp=0x00083;
	hs_func[0x22].func=hs_poke;
	hs_func[0x22].ptyp=0x00018;
	hs_func[0x23].func=hs_peek;
	hs_func[0x23].ptyp=0x00188;
	hs_func[0x24].func=hs_wpoke;
	hs_func[0x24].ptyp=0x00118;
	hs_func[0x25].func=hs_wpeek;
	hs_func[0x25].ptyp=0x00188;
	hs_func[0x26].func=hs_strlen;
	hs_func[0x26].ptyp=0x00089;
	hs_func[0x27].func=hs_getstr;
	hs_func[0x27].ptyp=0x0118A;
	hs_func[0x28].func=hs_exist;
	hs_func[0x28].ptyp=0x00002;
	hs_func[0x29].func=hs_strmid;
	hs_func[0x29].ptyp=0x0118A;
	hs_func[0x2a].func=hs_instr;
	hs_func[0x2a].ptyp=0x01289;
	hs_func[0x2c].func=hs_mref;
	hs_func[0x2c].ptyp=0x00313;
	hs_func[0x2f].func=hs_memcpy;
	hs_func[0x2f].ptyp=0x11188;
	hs_func[0x30].func=hs_memset;
	hs_func[0x30].ptyp=0x01118;
	hs_func[0x31].func=hs_notesel;
	hs_func[0x31].ptyp=0x00003;
	hs_func[0x32].func=hs_noteadd;
	hs_func[0x32].ptyp=0x00112;
	hs_func[0x33].func=hs_noteget;
	hs_func[0x33].ptyp=0x0001A;
	hs_func[0x34].func=hs_notemax;
	hs_func[0x34].ptyp=0x00009;
	hs_func[0x35].func=hs_notedel;
	hs_func[0x35].ptyp=0x00001;
	hs_func[0x36].func=hs_noteload;
	hs_func[0x36].ptyp=0x00002;
	hs_func[0x37].func=hs_notesave;
	hs_func[0x37].ptyp=0x00002;
	//0x48xx
	hs_func[0x2e|0x80].func=hs_exec;
	hs_func[0x2e|0x80].ptyp=0x00012;
	hs_func[0x2f|0x80].func=hs_mkdir;
	hs_func[0x2f|0x80].ptyp=0x00002;

	hs_func[0x36|0x80].func=hs_gettime;
	hs_func[0x36|0x80].ptyp=0x00019;
	hs_func[0x38|0x80].func=hs_randomize;
	hs_func[0x38|0x80].ptyp=0x00001;

	hs_func[0x3f|0x80].func=hs_chdir;
	hs_func[0x3f|0x80].ptyp=0x00002;

	hs_func[0x43|0x80].func=hs_sysinfo;
	hs_func[0x43|0x80].ptyp=0x00013;

	hs_func[0x49|0x80].func=hs_dirlist;
	hs_func[0x49|0x80].ptyp=0x0002a;
	hs_func[0x4a|0x80].func=hs_delete;
	hs_func[0x4a|0x80].ptyp=0x00002;

	unsigned short c,code,m;
	int &pt=hsinfo.pt;pt=p;
	int jp=0;
	long ptbuf[32];
	int d;
	int onval=0;
	while(pt*2<hsinfo.size){
		code=hsinfo.code[pt++];
		//printf("pt:%04x c:%04x\n",pt*2+0x50,c);
		if(code&0x8000){
			d=hsinfo.code[pt++]+(hsinfo.code[pt++]<<16);
		}else{
			d=code&0x1ff;
		}
		m=code>>11&0xf;
		if(m==0x4){
			//ѿ
			int dat[2]={d,0};
			pt+=readval(dat,hsinfo.code+pt);
			c = hsinfo.code[pt++];
			int sign = 0;
			if (c=='+') sign = 1;
			else if (c=='-') sign =-1;

			if (sign && (hsinfo.code[pt]&0x7800)==0) // +,-,=
				c=hsinfo.code[pt++];

			if ((c=='+' || c=='-') && (hsinfo.code[pt]&0x200)) {
				// inc/dec (++,+,--,-)
				hsinfo.vallist[d].pInt[dat[1]]+=sign;
				sign=255;
			}
			pt+=getprm(0,hsinfo.code+pt,&hsinfo);
			if(sign==1){
				if(prmm[0].type==1){
					hsinfo.vallist[d].pInt[dat[1]]+=prmm[0].i;
				}else if(prmm[0].type==2){
					strcat((char*)hsinfo.vallist[d].pStr+dat[1],prmm[0].s);
				}
			}else if(sign==-1){
				hsinfo.vallist[d].pInt[dat[1]]-=prmm[0].i;
			}else if(sign==0){
				int i=0,p=0;
				while(i<prms){
					if(prmm[0].type==1){
						hsinfo.vallist[d].pInt[dat[1]+i]=prmm[i].i;
						hsinfo.vallist[d].type=0;
						//printf("v.%d := %d \n",dat.p,prmm[i].i);
					}else if(prmm[0].type==2){
						strcpy((char*)hsinfo.vallist[d].pStr+dat[1]+p,prmm[i].s);
						hsinfo.vallist[d].type=1;
						p+=hsinfo.vallist[d].dsize[0];
					}
					i++;
				}
			}

			continue;
		}
		c=d|((code>>4)&0x80);
		if((m&0xE)==0x8 && hs_func[c].func){//ɸ̿
			//ꥹȤˤäƤӽФ
			pt+=getprm(hs_func[c].ptyp,hsinfo.code+pt,&hsinfo);
			//printf("(%d) %s,%s,%d,%d\n",prms,prmm[0].s,prmm[1].pStr,prmm[2].i,prmm[3].i);
			if((c=hs_func[c].func()) && hsinfo.fskiperr==0){
				//sval.err=c;
#ifdef HSPDBG
				char file[256];
				int line=getlineno(pt,file);
				if(hsinfo.onerror){
					pt=hsinfo.label[hsinfo.onerror];
					sval.wparam=c;
					sval.lparam=line;
				}else{
					char *msg="Error";
					if(c>0 && c<22)msg=err[c-1];
					if(hs_func[0x2c|0x80].func){
						prms=3;
						prmm[0].type=2;
						sprintf(prmm[0].s,"%s(%d)\nline:%d file:'%s'",msg,c,line,file);
						prmm[1].type=1;
						prmm[1].i=1;
						prmm[2].type=2;
						strcpy(prmm[2].s,"xhsp ERROR");
						hs_func[0x2c|0x80].func();
					}else{
						printf(prmm[0].s,"%s(%d) line:%d file:'%s'\n",msg,c,line,file);
					}
					return -c;
				}
#else
				if(hsinfo.onerror){
					pt=hsinfo.label[hsinfo.onerror];
					sval.wparam=c;
					sval.lparam=-1;
				}else{
					printf("error %d\n",c);
					return -c;
				}
#endif
			}
			continue;
		}
		if(m==0x8){
			if(d<9){//GOTO GOSUB
				pt+=getprm(0x0011,hsinfo.code+pt,&hsinfo);
				if(onval){
					if(onval<0 || onval>=prms)
						continue;
					prmm[0].i=prmm[onval].i;
					onval=0;
				}
			}
			if(d==0x09){//ON val cmd ...
				d=hsinfo.code[pt++];
				if(d&0x8000){
					d=hsinfo.code[pt++]+(hsinfo.code[pt++]<<16);
				}else{
					d=d&0x1ff;
				}
				int dat[2]={d,0};
				pt+=readval(dat,hsinfo.code+pt);
				onval=hsinfo.vallist[d].pInt[dat[1]];
				continue;
			}
			//printf("%d %d %d,\n",d,prmm[0].i,prms);
			switch(d){
			case 0x00://GOTO
				pt=hsinfo.label[prmm[0].i];
				continue;
			case 0x01://GOSUB
				ptbuf[sval.sublev]=pt;
				sval.sublev++;
				pt=hsinfo.label[prmm[0].i];
				continue;
			case 0x02://RETURN
				sval.sublev--;
				pt=ptbuf[sval.sublev];
				if(pt<0)return prmm[0].i;
				continue;
			case 0x03://BREAK
				c=hsinfo.code[pt]&0x1ff;
				sval.looplev--;
				pt=hsinfo.label[c];
				continue;
			case 0x04://onexit
				hsinfo.onexit=prmm[0].i;
				continue;
			case 0x05://onkey
				hsinfo.onkey=prmm[0].i;
				continue;
			case 0x06://onclick
				hsinfo.onclick=prmm[0].i;
				continue;
			case 0x07://oncmd
				//hsinfo.oncmd=prmm[0].i;
				continue;
			case 0x08://onerror
				hsinfo.onerror=prmm[0].i;
				continue;
			case 0x0a://exgoto
				pt+=getprm(0x1111,hsinfo.code+pt,&hsinfo);
				if((prmm[1].i<0)?(prmm[0].i<=prmm[2].i):(prmm[0].i>=prmm[2].i))
					pt=hsinfo.label[prmm[3].i];
				continue;
			case 0x11: //REPEAT
				c=hsinfo.code[pt]&0x1ff;
				pt++;
				sval.looplev++;
				hsinfo.loop[sval.looplev].ept=hsinfo.label[c];

				pt+=getprm(0x0011,hsinfo.code+pt,&hsinfo);

				hsinfo.loop[sval.looplev].spt=pt;
				hsinfo.loop[sval.looplev].ed=prmm[0].i+prmm[1].i;
				hsinfo.loop[sval.looplev].cnt=prmm[1].i;
				if(prms==0)
					hsinfo.loop[sval.looplev].ed=-1;
				if(hsinfo.loop[sval.looplev].cnt<hsinfo.loop[sval.looplev].ed
					|| hsinfo.loop[sval.looplev].ed<0){
					pt=hsinfo.loop[sval.looplev].spt;
				}else{
					pt=hsinfo.loop[sval.looplev].ept;
					sval.looplev--;
				}
				continue;
			case 0x12: //LOOP
				hsinfo.loop[sval.looplev].cnt++;
				if(hsinfo.loop[sval.looplev].cnt<hsinfo.loop[sval.looplev].ed || hsinfo.loop[sval.looplev].ed<0)
					pt=hsinfo.loop[sval.looplev].spt;
				else
					sval.looplev--;
				continue;
			case 0x2b: //CONTINUE
				pt++; //?
				hsinfo.loop[sval.looplev].cnt++;
				pt+=getprm(0x0001,hsinfo.code+pt,&hsinfo);
				if(prms)hsinfo.loop[sval.looplev].cnt=prmm[0].i;
				if(hsinfo.loop[sval.looplev].cnt<hsinfo.loop[sval.looplev].ed || hsinfo.loop[sval.looplev].ed<0)
					pt=hsinfo.loop[sval.looplev].spt;
				else{
					pt=hsinfo.loop[sval.looplev].ept;
					sval.looplev--;
				}
				continue;
			}
		}
		//if(m==0xA){//DLL̿
		//	continue;
		//}
		if(m==0xB){//IF, ELSE
			jp=pt+hsinfo.code[pt++]+1;
			pt+=getprm(0x0001,hsinfo.code+pt,&hsinfo);
			if(d==0x00 && prmm[0].i ==0 )pt=jp; //IF
			if(d==0x01)pt=jp; //ELSE
			continue;
		}
		if(m==0xC){//⥸塼
			d-=0x10;
			int i=0x11111100;
			i+=((hsinfo.modlist[d].type&0x1111)<<1) | hsinfo.modlist[d].type;
			pt+=getprm(i,hsinfo.code+pt,&hsinfo);
			memcpy(modprm,prmm,sizeof(PARAM)*8);
			ptbuf[sval.sublev]=pt;
			sval.sublev++;
			pt=hsinfo.modlist[d].pt;
			continue;
		}
		if(m==0xF){//END
			/*if(d==0x00)*/ return prmm[0].i; //END
		}
		pt+=getprm(0x0000,hsinfo.code+pt,&hsinfo);
	}
	return 0;
}

int getsysval(int &d,char *&s){
	int type=1;
	int dmy;
	if(d==0x01)d=HSPSTAT;
	else if(d==0x02)d=HSPVER;
	else if(d==0x03)d=hsinfo.loop[sval.looplev].cnt;
	else if(d==0x04)d=0; //err
	else if(d==0x05)d=sval.strsize;
	else if(d==0x06)d=sval.looplev;
	else if(d==0x07)d=sval.sublev;
	else if(d==0x40)gui_getPointer(&d,&dmy);
	else if(d==0x41)gui_getPointer(&dmy,&d);
	else if(d==0x42)gui_getCurrentPos(&d,&dmy);
	else if(d==0x43)gui_getCurrentPos(&dmy,&d);
	else if(d==0x47)d=sval.rval;
	else if(d==0x48)d=sval.gval;
	else if(d==0x49)d=sval.bval;
	else if(d==0x4a)d=sval.stat;
	else if(d==0x4b)gui_getWinsize(&d,&dmy);
	else if(d==0x4c)gui_getWinsize(&dmy,&d);
	else if(d==0x4f)d=sval.iparam;
	else if(d==0x50)d=sval.wparam;
	else if(d==0x51)d=sval.lparam;
	else if(d==0x60){type=2;s=sval.cmdline;}
	else if(d==0x62){type=2;s=sval.curdir;}
	else if(d==0x63){type=2;s=sval.refstr;}
	return type;
}

int readval(int dat[],const unsigned short *code){
	//ѿ
	int pt=0;
	int c,d;
	dat[1]=0;
	int n=1,i=0;
	if(hsinfo.vallist[dat[0]].type){
		i=1;
		n=hsinfo.vallist[dat[0]].dsize[0];
	}
	while(code[pt]==0x002e){
		pt++;
		c=code[pt];
		pt++;
		if(c&0x8000){
			c^=0x8000;
			d=code[pt]+(code[pt+1]<<16);
			pt+=2;
		}else{
			d=c&0x1ff;
		}
		if(c>>9==0x10){//val
			d=hsinfo.vallist[d].pInt[0];
		}
		if(c>>9==0x1c){
			char *s;
			getsysval(d,s);
		}
		dat[1]+=d*n;
		n*=hsinfo.vallist[dat[0]].dsize[i];
		i++;
	}
	return pt;
}

int getprm(int prmtyp, const unsigned short *code,const HSP_INFO *ax){
	static PARAM kbuf[32];
	static int calbuf[2];
	int c;
	int pt=0;
	int d,type;
	int kn=0;
	char *s;
	kbuf[0].mode=0;
	kbuf[0].mode2=0;
	kbuf[0].i=0;
	prms=0;
	for(int i=0;i<8;i++){
		prmm[i].type=-1;
		prmm[i].i=0;
	}
	if(code[pt]&0x0200){
		return 0;
	}
	//while((hsinfo.pt+pt)*2<hsinfo.size){
	while(1){
		if((hsinfo.pt+pt)*2<hsinfo.size){
			c=code[pt];
		}else{
			c=0x600;
		}
		if(c&0x0600){
			//ѥ᡼ڤ or 
			switch(prmtyp&0xf){
			case 0:
				if(kbuf[0].type==2){
					prmm[prms].type=2;
					strcpy(prmm[prms].s,kbuf[0].s);
				}else{
					prmm[prms].type=1;
					prmm[prms].i=kbuf[0].i;
				}
				break;
			case 1:
				prmm[prms].type=1;
				if(kbuf[0].type==2){
					prmm[prms].i=atoi(kbuf[0].s);
				}else{
					prmm[prms].i=kbuf[0].i;
				}
				break;
			case 2:
				prmm[prms].type=2;
				if(kbuf[0].type==2){
					strcpy(prmm[prms].s,kbuf[0].s);
				}else{
					sprintf(prmm[prms].s,"%d",kbuf[0].i);
				}
				break;
			case 3:
			case 4:
				break;
			case 5:
				prmm[prms].type=5;
				prmm[prms].i=kbuf[0].i;
				break;
			}
			if(kbuf[0].mode=='?'){
				//ά
				prmm[prms].type=-1;
			}
			prms++;
			if(c&0x0200){
				break;
			}
			kn=0;
			kbuf[0].mode=0;
			kbuf[0].i=0;
			prmtyp>>=4;
			//prmm[prms].type=-1;
		}
		pt++;
		if(c&0x8000){
			d=code[pt]+(code[pt+1]<<16);
			pt+=2;
		}else{
			d=c&0x1ff;
		}
		//printf("%d\n",d);
		c=(c>>11)&0xf;
		switch(c){
		case 0x0://黻
			type=-1;
			break;
		case 0x1://
			type=1;
			break;
		case 0x2://ʸ
			s=(char*)ax->str+d;
			type=2;
			break;
		case 0x3://٥
			type=4;
			break;
		case 0x4://ѿ
			type=5;
			calbuf[0]=d;
			pt+=readval(calbuf,code+pt);
			if((prmtyp&0xf)==3){//ѿ
				prmm[prms].type=3;
				prmm[prms].p=calbuf[1];
				prmm[prms].i=d;
				continue;
			}else if(prmtyp&0x8){//Хåե
				//printf("%d : %s\n",prms,ax->vallist[d].pStr);
				if((prmtyp&0xf)==9){
					ax->vallist[d].type=0;
				}else if((prmtyp&0xf)==10){
					ax->vallist[d].type=1;
				}
				if(ax->vallist[d].type){
					prmm[prms].pStr=(char *)ax->vallist[d].pStr+calbuf[1];
					prmm[prms].type=0x14;
				}else{
					prmm[prms].pInt=ax->vallist[d].pInt+calbuf[1];
					prmm[prms].type=0x4;
				}
				continue;
			}else{//Ƥ
				if(ax->vallist[d].type){
					type=2;
					s=(char*)ax->vallist[d].pStr+calbuf[1];
				}else{
					type=1;
					d=ax->vallist[d].pInt[calbuf[1]];
				}
			}
			break;
		case 0x7://ƥѿ
			type=getsysval(d,s);
			break;
		default:
			type=0;
		}
again:
		switch(type){
		case -1:
			if(d=='('){
				kn++;
				kbuf[kn].mode=0;
				kbuf[kn].type=0;
				kbuf[kn].i=0;
				continue;
			}
			if(d==')'){
				d=kbuf[kn].i;
				type=kbuf[kn].type;
				kn--;
				goto again;
			}
			if(kbuf[kn].mode){
				kbuf[kn].mode2 = d=='-';
			}else{
				kbuf[kn].mode2 = 0;
				kbuf[kn].mode=d;
			}
			break;
		case 2:
			//ʸ
			if(kbuf[kn].type==2 || kbuf[kn].mode== 0){
			kbuf[kn].type=2;
			if(kbuf[kn].mode== 0 ) {
				strcpy(kbuf[kn].s,s);
			}
			if(kbuf[kn].mode=='+') {
				strcat(kbuf[kn].s,s);
			}
			if(kbuf[kn].mode=='=') {
				kbuf[kn].i=!strcmp(kbuf[kn].s,s);
				kbuf[kn].type=1;
			}
			if(kbuf[kn].mode=='!') {
				kbuf[kn].i=strcmp(kbuf[kn].s,s);
				kbuf[kn].type=1;
			}
				break;
			}
			type=1;
			d=atoi(s);
		case 1:
			//
			if(kbuf[kn].mode=='+'){
				if(kbuf[kn].type==2){
					sprintf(kbuf[kn].s+strlen(kbuf[kn].s),"%d",d);
				}else
					kbuf[kn].i+=d;
			}else{
				kbuf[kn].type=type;
			}
			if(kbuf[kn].mode2){
				d=-d;
			}
			switch(kbuf[kn].mode){
			case '-': kbuf[kn].i -= d;
				break;
			case '*': kbuf[kn].i *= d;
				break;
			case '/': kbuf[kn].i /= d;
				break;
			case '\\':kbuf[kn].i %= d;
				break;
			case '&': kbuf[kn].i &= d;
				break;
			case '|': kbuf[kn].i |= d;
				break;
			case '^': kbuf[kn].i ^= d;
				break;
			case '=': kbuf[kn].i=kbuf[kn].i == d;
				break;
			case '!': kbuf[kn].i=kbuf[kn].i != d;
				break;
			case '<': kbuf[kn].i=kbuf[kn].i <  d;
				break;
			case '>': kbuf[kn].i=kbuf[kn].i >  d;
				break;
			case 'a': kbuf[kn].i=kbuf[kn].i <= d;
				break;
			case 'b': kbuf[kn].i=kbuf[kn].i >= d;
				break;
			case 'c': kbuf[kn].i<<= d;
				break;
			case 'd': kbuf[kn].i>>= d;
				break;
			case 0:   kbuf[kn].i  = d;
				break;
			}
			//printf("%d:%d %d\n",kn,kbuf[kn].i,d);
			kbuf[kn].mode=0;
			break;
		case 4:
			//٥
			kbuf[kn].type=type;
			kbuf[kn].i =d;
			break;
		}
	}
	return pt;
}

////////////////////////////////////////////////////////////////////
//		AXե

bool ax_load(HSP_INFO &axdat,char *lpFile){
	int size=dpm_exist(lpFile);
	if(size<1)
		return false;
	axdat.buf=(unsigned char*)malloc(size+64);
	if(dpm_load(axdat.buf,size,lpFile,0)==false)
		return false;

	AXHEAD* head=(AXHEAD*)axdat.buf;
	axdat.code=(unsigned short*)(axdat.buf+head->code_start);
	axdat.str=(unsigned char*)(axdat.buf+head->str_start);
	axdat.label=(int*)(axdat.buf+head->label_start);
	axdat.size=head->code_size;
	axdat.vcnt=head->valcnt;
	axdat.modlist=(MODINFO*)(axdat.buf+head->mod_start);
	axdat.vallist=(PVAL*)malloc(sizeof(PVAL)*axdat.vcnt);
	memset(axdat.vallist,0,sizeof(PVAL)*axdat.vcnt);
	for(int i=0;i<axdat.vcnt;i++){
		axdat.vallist[i].type=0;
		axdat.vallist[i].mode=2;
		axdat.vallist[i].size=256;
		axdat.vallist[i].pInt=(int*)malloc(256);
		memset(axdat.vallist[i].pInt,0,256);
	}
	return true;
}

void ax_free(const HSP_INFO &ax)
{
	if(hsinfo.buf)
		free(hsinfo.buf);
	if(hsinfo.vallist){
		for(int i=0;i<hsinfo.vcnt;i++){
			if(hsinfo.vallist[i].mode==2)free(hsinfo.vallist[i].pStr);
		}
		free(hsinfo.vallist);
	}
}

////////////////////////////////////////////////////////////////////
//		ե

void dpm_set(char*file, long offset){
	dpm.hPF=fopen(file,"rb");
	if(dpm.hPF == NULL)
		return;
	fseek(dpm.hPF,0,SEEK_END); //!?
	if(ftell(dpm.hPF)<=offset){
		fclose(dpm.hPF);
		return;
	}
	fseek(dpm.hPF,0,SEEK_SET);
	strcpy(dpm.file,file);
	dpm.offset=offset;
	dpm.flag=1;
}

FILE* hsp_fopen(char *lpFile,long *size){
	FILE *fp;
	*size=-1;
	if(dpm.flag){
		long DPMofset=dpm.offset;
		fp=dpm.hPF;
		fseek(fp,DPMofset,SEEK_SET);
		int hed[16];
		if(fread(hed,1,16,fp)!=16){
			fclose(fp);
		//	return false;
		}
		long n=0;
		struct INFO{
			char fname[16];
			long dummy[2];
			long start;
			long size;
		} info;
		while(n<hed[2]){
			fread(&info,1,sizeof(info),fp);
			if(strcmp(lpFile,info.fname)==0){
				fseek(fp,DPMofset+16+hed[2]*sizeof(info)+info.start,SEEK_SET);
				if(size)*size=info.size;
				return fp;
			}
			n++;
		}
	}
	fp=fopen(lpFile,"rb");
	if(fp && size){ //?
		fseek(fp,0,SEEK_END);
		*size=ftell(fp);
		fseek(fp,0,SEEK_SET);
	}
	return fp;
}

int hsp_fclose(FILE *fp){
	if(fp && fp!=dpm.hPF){
		fclose(fp);
	}
	return 0;
}

int dpm_exist(char *lpFile){
	long fsize;
	FILE *fp=hsp_fopen(lpFile,&fsize);
	hsp_fclose(fp);
	return fsize;
}


bool dpm_load(void *buf, int size, char *lpFile,int offset){
	long fsize;
	FILE *fp=hsp_fopen(lpFile,&fsize);
	if(!fp)return false;
	if(offset>=fsize){
		sval.strsize=0;
		hsp_fclose(fp);
		return false;
	}
	if(offset)fseek(fp,offset,SEEK_CUR);
	if(size==0){
		size=fsize-offset;
	}else if(size>fsize-offset){
		size=fsize-offset;
	}
	sval.strsize=fread(buf,1,size,fp);
	hsp_fclose(fp);
	return true;
}


bool bsave(void *buf, int size, char *lpFile)
{
	FILE *fp=fopen(lpFile,"wb");
	if(fp == NULL)
		return false;
	fwrite(buf,1,size,fp);
	fclose(fp);
	return true;
}

bool bsave2(void *buf, int size, char *lpFile, int offset)
{
	FILE *fp=fopen(lpFile,"r+b");
	if(fp == NULL)
		return false;
	fseek(fp,offset,SEEK_SET);
	fwrite(buf,1,size,fp);
	fclose(fp);
	return true;
}

////////////////////////////////////////////////////////////////////

